unit IsInternetComponents;

interface
uses Windows, {IsIntnet,} Dialogs, LibBits, Forms,
     Graphics, classes, sysutils, Messages, SyncObjs,
     Controls, FileCtrl{for filter,etc},
     IdFTP,IdStackConsts, stdctrls;

Const
  MaxFileToTransfer=30;
  DeleteIterateDepth=15;
  DefUser='anonymous';
  DefPass='email@default.com';
  DefHost='localhost';
  chrTab=Chr(9);
  MaxTabs=5;
  NtDirStart=25;
  NtNameStart=40;
  NtSize=30;
  UnixSizeSize=12;
  UnixDateSize=12;
  UnixAccess=15;
Var
  UnixNameStart:Integer=55;
Type
  TFTPServerRecord= Record
     Username,HostName,
     BaseDirFileName,
     Password:String;
    End;

  TDirRecObj = Class(TObject)
    Private
     FNext,FChild,FUpper:TDirRecObj;
     FFileName,FThisDirFullName:String;
     FDirBitMap:Pointer;
     FDirSep:Char;
     Function    AddObjToList(NewObj:TDirRecObj):TDirRecObj;
     Function    FindFullThisLevel(Const FullDirName:String):TDirRecObj;
     Function    GetPathName(Const AFullFileName:String):String;
    Public
     Constructor Create(Const AFullDirName:String;Var CreateDir:TDirRecObj);
     Destructor  Destroy;Override;
     Function OneDirStepRef(Const AFullDirName:String):String;
     Function FindFullNameDownLevel(Const FullDirName:String):TDirRecObj;
     Function FindExistingBestMatch(Const FullDirName:String):TDirRecObj;
     Function MinimiseName(MaxLen:Integer;Canvas:TCanvas):String;
     Function BuildRelativeNetPathName(Const LocalFileName,LocalBaseDirectory:String):String;
     Function BuildRelativeLocalPathName(Const NetFileName,LocalBaseDirectory:String):String;
     Function MakeFullNetFileName(Const LocalFileName:String):String;
     Function FileMatchesDirectory(Const AFullFileName:String):Boolean;
//     Function AddFullName(FullDirName:String):TDirRecObj;
//    Function AddChildFile(Const RelativeDirName:String):TDirRecObj;
//     Function GetDir(Const RelativeDirName:String):TDirRecObj;
     Property FullFileName:String Read FThisDirFullName;
     Property FileName:String Read FFileName;
     Property DirBitMap:Pointer Read FDirBitMap Write FDirBitMap;
    end;

   TYesNoDontKnow=(ynYes,ynNo,ynDontKnow);
   TINetFileBx=class;
   TFTPDirThread=class;

{TINetDirBx}
   TINetDirBx=Class(TCustomListBox)
    Private
     FTryUpdateTimer:TDateTime;
     FDirFTPThread:TFTPDirThread;
     NetopenBMP,NetCloseBMP,
     ExeBMP, UnknownBMP,
     ClosedBMP, OpenedBMP, CurrentBMP,
     TxtBMP,PicBMP: TBitmap;
     FDirLabel: TLabel;
     FFileList: TINetFileBx;
     FCurrentServer:TFTPServerRecord;
     FFileExisting:String;
     FFileExistingCompleted,FFileExistBusy:Boolean;
     FFileReadListCompleted,FReadListBusy:Boolean;
     FFileReadlistReturnList:TStrings;
     {FBaseDir,FTopDir,}FCurrentDirectory:TDirRecObj;
     FDirectory:String; //use for local static stuff
     FOnReportFTPErrors:TGetStrProc;
     Function   BldRootDirectory:String;
     Procedure  BuildList(Siblings:TStringList);
     Procedure  ModifyServerDetails(Const AHostName,AUser,APassword:String);
     Function   GetDirectory:string;
     procedure  CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
     Function   DirectorySeparator:Char;
     Procedure  LaunchChangeServer(NewServer: TFTPServerRecord);
     Procedure  LaunchResetFTPDir;
     Procedure  LaunchBuildList;
     Procedure  LaunchSetMakeDirectory(DirName:String;MakeIfNeeded:Boolean);
     Procedure  LaunchRename(ACurrentFileName,ANewFileName:String);
     Function   GetHost:String;
     Function   GetUser:String;
     Function   GetPassword:String;
     procedure  ReadBitmaps; virtual;
     Procedure  ResetItemHeight;
     Procedure  SetDirectory(DirectoryName:string);
     Procedure  SetHost(s:string);
     Procedure  SetUser(s:String);
     Procedure  SetPassword(s:String);
     Procedure  SetNetFileList(Value: TINetFileBx);
     Function   ReconstructFileDetails(Const FileName,Details:String):String;
     Function   ShouldShow(ErrorS:String):boolean;
     Function   UnixDirStructure:Boolean;
//
     Procedure   FileExistsReturn(ReturnList:TStringList);
     Procedure   ReadAllFilesInNetDirectoryReturn(ReturnList:TStringList);
//
    Protected
     FOnChange: TNotifyEvent;
     Procedure  SetDirLabelCaption;
     procedure  Change; virtual;
     procedure  KeyPress(var Key: Char); override;
     procedure  DblClick; override;
     procedure  Update; reintroduce;
     procedure  CreateWnd; override;
     procedure  DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState); override;
     procedure  Notification(AComponent: TComponent; Operation: TOperation); override;
     procedure  DragOver(Source: TObject; X, Y: Integer; State: TDragState;
                var Accept: Boolean); Override;
    Public
     constructor Create(AOwner: TComponent); override;
     destructor  Destroy; override;
     Procedure   RefreshIfFileInDirectory(FName:String);
     Function    GetDragObject:TDragObject;
     Property    CurrentDirectoryRecord:TDirRecObj Read FCurrentDirectory;
     Function    FullDirectoryName:String;
     Function    TryUpdate(DoNow:Boolean):Boolean;
     Function    ListOfCurrentFilesInDir:TStringlist;// read FListOfCurrentFilesInDir;
     Function    ExtendedFileList:TStringList;// read FExtendedFileDescription;
//
     Procedure   DeleteFile(const AFileName: String);
     Function    FileExists(AFileName:string):TYesNoDontKnow;
     Procedure   DeleteListOfFiles(AList:TStringList;Continue:Boolean);
     Function    ReadAllFilesInNetDirectory(FullDirPath,AMask: string;
                        AFileList: TStrings; LayersOfSubDir, MaxFileCount: Integer):TYesNoDontKnow;
     Procedure   DeleteDirectoryRecord(Const ADirName:String);
     Property    FTPServerDetails:TFTPServerRecord Read FCurrentServer Write LaunchChangeServer;
//
 Published
     property Align;
     property Anchors;
     property Color;
     property Ctl3D;
     property Directory: string read GetDirectory write SetDirectory;
     property DirLabel: TLabel read FDirLabel write FDirLabel;//SetDirLabel;
     property DragCursor;
     property DragMode;
     property Enabled;
     property Font;
     property Host:String Read GetHost Write SetHost;// Default DefHost;
     property ImeMode;
     property ImeName;
     property ItemHeight;
     property NetFileList: TINetFileBx read FFileList write SetNetFileList;// SetFileListBox;
     Property OnReportFTPErrors:TGetStrProc Read  FOnReportFTPErrors Write FOnReportFTPErrors;
     property ParentColor;
     property ParentCtl3D;
     property ParentFont;
     property ParentShowHint;
     property Password:String Read GetPassword Write SetPassword;// Default DefPass;
     property PopupMenu;
     property ShowHint;
     property TabOrder;
     property TabStop;
     property User:String Read GetUser Write SetUser;// default DefUser;
     property Visible;
     property OnChange: TNotifyEvent read FOnChange write FOnChange;
     property OnClick;
     property OnContextPopup;
     property OnDblClick;
     property OnDragDrop;
     property OnDragOver;
     property OnEndDrag;
     property OnEnter;
     property OnExit;
     property OnKeyDown;
     property OnKeyPress;
     property OnKeyUp;
     property OnMouseDown;
     property OnMouseMove;
     property OnMouseUp;
     property OnStartDrag;
    End;

{ TINetFileBx }

  TINetFileBx = class(TCustomListBox)
  private
    FDefaultBitMap:TBitmap;
    FLongFormFiles:Boolean;
    FFileEdit:TEdit;
    FRenameEdit:TEdit;
    FCurrentFileName:String;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
    function  GetFileName: string;
    function  GetFullFileName: string;
    Function  MatchMask(Const FileNam:String):Boolean;
    procedure SetFileEdit(Value: TEdit);
    Procedure SetNetDirList(Value:TINetDirBx);
{    procedure SetDirectory(const NewDirectory: string);}
    procedure SetMask(const NewMask: string);
{    procedure SetFileName(const NewFile: string);}
    procedure SetShowGlyphs (Value: Boolean);
    Procedure SetLongFormFiles(Value:Boolean);
    procedure ResetItemHeight;
    procedure InPlaceEditOnKeyPress(Sender: TObject; var Key: Char);
    procedure InPlaceEditOnExit(Sender: TObject);
    Procedure RenameFile(const ACurrentFileName,ANewFileName: String);
    Function  ExtractShortFileName(Const FileName:String):String;
  protected
    FDirectory: string;
    FMask: string;
    FtabWidth:array [1..MaxTabs] of integer;
    FDirList: TINetDirBx;
    FDirSep:char;
    FFilterCombo: TFilterComboBox;
    FOnChange: TNotifyEvent;
    FLastSel: Integer;
    FShowGlyphs: Boolean;
    Procedure BumpTabs(FName:String);
    procedure Click; override;
    procedure Change; virtual;
    procedure CreateWnd; override;
    procedure DblClick; override;
    procedure ReadFileNames; virtual;
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);  override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure DragOver(Source: TObject; X, Y: Integer; State: TDragState;
                var Accept: Boolean); Override;
    Function  SelectedIsDir:Boolean;
  public
    constructor Create(AOwner: TComponent); override;
    Destructor  Destroy; override;
    procedure Update; reintroduce;
    Function  GetDragObject:TDragObject;
    Procedure RenameEdit;
    {
    procedure ApplyFilePath (const EditText: string); virtual;}
    property Directory: string read FDirectory;// write ApplyFilePath;
    property FileName:  string read GetFileName;// write ApplyFilePath;
    property FullFileName:  string read GetFullFileName;// write ApplyFilePath;
  published
    property Align;
    property Anchors;
    property Color;
    property Constraints;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property ExtendedSelect;
    Property FileDetails:Boolean Read FLongFormFiles Write SetLongFormFiles;
    Property FileEdit:TEdit Read FFileEdit Write SetFileEdit;
    property Font;
    property ImeMode;
    property ImeName;
    property ItemHeight;
    property IntegralHeight;
    property Mask: string read FMask write SetMask;
    property MultiSelect;
    Property NetDirectoryList: TINetDirBx Read   FDirList Write SetNetDirList;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowGlyphs: Boolean read FShowGlyphs write SetShowGlyphs;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
  end;

TStringListProcedure=procedure(TxtList:TStringList) of object;

TFTPActions = (taList,taListDetails,taBuildList,taChangeServer,
               taResetDir,taSetDir,taCreateDir,taRmDir,taRename,
               taDeleteF,taExistF,taDeleteFileList,
               taIterateAllFiles);

TFTPCompActionList = Class(TObject)
  Private
    Next:TFTPCompActionList;
    Action:TFtpActions;
    CommandAction:String;
    ListParameter:TStringList;
    ReturnProc:TStringListProcedure;
    IterateDepth,LimitSize:Integer;
    Procedure AddToList(NewOne:TFTPCompActionList);
  Public
    Destructor Destroy; override;
 end;

{TFTPDirThread}
TFTPDirThread = Class(TThread)
   Private
     FCurAction:TFTPCompActionList;
     FCommandList:TFTPCompActionList;
     FCurrentThreadServer:TFTPServerRecord;
     //FSvEnable:Boolean;
     FSvCursor:TCursor;
     FResultList:TStringList;
     FDirectoryObject:TINetDirBx;
     FFTPClient:TIdFTP;
     FObjLock:TCriticalSection;
     FDirSep:Char;
     FNetDirectory:String;
     FBusyCount:Integer;
     FDirRecursionCheck:Integer;
     FUnixDirStructure: Boolean;
     FBaseDir,FTopDir,FCurrentDirectory,FSvCurIndexObj:TDirRecObj;
     FListOfCurrentFilesInDir,FExtendedFileDescription,
     FListOfNetDir:TStringList; //includes bitmaps
     FReadAllFilesReturn:TYesNoDontKnow;
     //VCL Block
     Procedure  PushList(Item:TFTPCompActionList);
     //Synchronize
     Procedure  BusyCursorAndDisable;
     Procedure  RecoverValues;//Synchonized
     Procedure  ReturnProcedure;
     // FTP Client Exposed - Readonly - VCL and Thread Access Permitted
     Function   Connected:Boolean;
     Function   Host:String;
     Function   Password:String;
     Function   User:String;
     //Thread Execute Functions - driven by an action request - may also be used "Privately"
     Procedure  ChangeServer;                                     //taChangeServer
     Procedure  DeleteDirectoryRecord(Const ADirName:String);     //taRmDir
     Procedure  DeleteListOfFilesFile(AList: TStringList);        //taDeleteFileList
     Function   DeleteSingleFile(Const AFileName:String):Boolean; //taDeleteF
     Function   SetMakeDirectory(AFullFileName:String; AMakeDirOnServer:Boolean;
                        AMaxIterateDepth:Integer):Boolean;        //taSetDir,taCreateDir
     procedure  ResetCurrentFTPDir;                               //taResetDir
     Procedure  RenameFile(RenameCommand:String);                 //taRename
     Function   FileExists(AFileName:string):Boolean;             //taExistF
     Function   ReadAllFilesInNetDirectory(FullDirPathAndMask:string;AFileList:TStrings;
                               LayersOfSubDir,MaxFileCount:Integer):TYesNoDontKnow;
                                                                  //taIterateAllFiles
     Procedure  ReadFtpDirectoryNames;                            //taBuildList
                 // FTP.List                                      //taList,taListDetails

     //Thread Private Functions
     Function   CheckCurrentConnection:Boolean;
     Function   ExtractShortNetFileName(Const FileName:String):String;
     Function   PopList:TFTPCompActionList;
     Procedure  ReportFTPErrors(AString:String);
     procedure  SetDirectory(const NewDirectory: string);
     Procedure  UpdateCurrentNetDir;
  Protected
     Procedure   Execute; Override;
   Public
     constructor Create;
     Destructor  Destroy; Override;
   end;


TNetFileDrag=Class(TDragObject)
   Private
     FNetDir:TDirRecObj;
     FNetFileName:String;
     FNetFileList:TStringList;
   Protected
     procedure Finished(Target: TObject; X, Y: Integer; Accepted: Boolean); override;
   Public
     Destructor Destroy; Override;
{     Function LocalFileEquivilant(Const NetFileName,LocalBasePath,NetBasePath:String);
}
     Function Multiple:Boolean;
     Function IsDirectory:Boolean;
     Function FullNetFileName:String;
     Function FileName:String;
     Property NetFileList:TStringList Read FNetFileList;
{     Procedure AddDirectory(AFileList:TStrings;
                            Const CurNetBasePath:String; NetDirBx:TINetDirBx;);
              // Afilelist contains File Names and  Flagged Directorys "dirname/"
              // If NetDirBx is provided and is connected it will recuse any subdirectories
}
   end;

TLclFileBx=Class(TFileListBox)
   Private
     TxtBMP,PicBMP: TBitmap;
    Protected
      function  GetFilePath: string; override;
      procedure ReadFileNames; override;
      Procedure ReadBitMaps;override;
      Procedure DblClick;override;
    Public
      Destructor Destroy;override;
   end;


procedure Register;

implementation

{$R IsInternetComponents}
function GetFontHeight(Font: TFont): Integer;
var
  DC: HDC;
  SaveFont: HFont;
  Metrics: TTextMetric;
begin
  DC := GetDC(0);
  SaveFont := SelectObject(DC, Font.Handle);
  GetTextMetrics(DC, Metrics);
  SelectObject(DC, SaveFont);
  ReleaseDC(0, DC);
  Result := Metrics.tmHeight;
end;

procedure Register;
begin
  RegisterComponents('Innova', [TINetDirBx,TINetFileBx,TLclFileBx]);
end;

Const
  ReturnValueNullResult='Some funny Value ***##$$#';
  ReturnValueValidResult='Some Other Funny Value ###**$$';
  FileNameSeparater=' >#> ';
{ TInetDirBx }

function TINetDirBx.BldRootDirectory: String;
Var
    TempPath: string;                
begin
    Result :='No FTP Connection' ;
    If FDirFTPThread=nil then Exit;
    If not FDirFTPThread.Connected then exit;
    If FCurrentDirectory=nil then SetDirectory('');
    TempPath := Directory;
    with FDirFTPThread do
      If(TempPath<>'')and(TempPath[1]='/')Then
          Result :=Host+'::'
         else
          Result :=Host+'::'+User;
end;


procedure TINetDirBx.BuildList(Siblings: TStringList);//Syncronised Return
// All Files are Read in Current Directory

var
  DirName: string;
  I: Integer;
  NewSelect: Integer;
  IncDirRec:TDirRecObj;
  LDirSep:Char;
begin
    NewSelect:=-1;
  try
    Items.BeginUpdate;
    Items.Clear;
    If (FDirFTPThread=nil)or((ComponentState*[CsDesigning,CsLoading,csDestroying])<>[]) then
        Begin Items.AddObject(BldRootDirectory, NetCloseBMP);Exit; end;
    if(ComponentState<>[])and(ComponentState<>[csFreeNotification]) then exit;
    If (FDirFTPThread.Connected)then
           Items.AddObject(BldRootDirectory, NetopenBMP)
         Else
           Items.AddObject(BldRootDirectory, NetCloseBMP);
     //All done if no current Directory
    {Inc(IndentLevel);}
    LDirSep:=FDirFTPThread.FDirSep;
    if Siblings<>nil then
     Begin
      If FCurrentDirectory=nil then Exit;
      IncDirRec:=FCurrentDirectory;
      While IncDirRec<>nil do
       If IncDirRec=FDirFTPThread.FBaseDir then IncDirRec:=nil
         Else
           Begin
             IncDirRec.DirBitMap:=OpenedBMP;
             Items.InsertObject(1,IncDirRec.FileName,Pointer(IncDirRec));
             IncDirRec:=IncDirRec.FUpper;
           end;
      FCurrentDirectory.DirBitMap:=CurrentBMP;
      NewSelect := Items.Count - 1;
      for i := 0 to Siblings.Count - 1 do
          Begin
           If FCurrentDirectory.FThisDirFullName=LDirSep then
              DirName:=FCurrentDirectory.FThisDirFullName+Siblings[i]
            else
              DirName:=FCurrentDirectory.FThisDirFullName+ LDirSep+
                                        Siblings[i];
           IncDirRec:=FCurrentDirectory.FindExistingBestMatch(DirName);
           If(IncDirRec<>nil)and(IncDirRec.FullFileName<>DirName)then
                  TDirRecObj.Create(DirName,FCurrentDirectory);
          end;
      IncDirRec:=FCurrentDirectory.FChild;
      While IncDirRec<>nil do
       Begin
         IncDirRec.DirBitMap:=ClosedBMP;
         Items.AddObject(IncDirRec.FileName,Pointer(IncDirRec));
         IncDirRec:=IncDirRec.FNext;
       end;
     end//Siblings<>nil;
    else
       Items.AddObject('No Connection', ClosedBMP);
  finally
    Items.EndUpdate;
  end;
  if HandleAllocated then
    ItemIndex := NewSelect;
end;

procedure TINetDirBx.Change;
begin
  if FFileList <> nil then FFileList.ReadFileNames;
  SetDirLabelCaption;
  if Assigned(FOnChange) then FOnChange(Self);
end;



procedure TINetDirBx.CMFontChanged(var Message: TMessage);
begin
  inherited;
  ResetItemHeight;
end;

constructor TINetDirBx.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Width := 145;
  Style := lbOwnerDrawFixed;
  Sorted := False;
  ReadBitmaps;
//  GetDir(0, FNetDirectory); { initially use current dir on default drive }
  ResetItemHeight;
  If ([CsDesigning]*ComponentState=[]) then
     FDirFTPThread:=TFTPDirThread.Create; //set to nil for designing
//ATimeout     ??????
  FCurrentServer.Username:= DefUser;
  FCurrentServer.Password:=DefPass;
  FCurrentServer.HostName:=DefHost;
  //items.Add(BldRootDirectory); no parent error in create
end;

procedure TINetDirBx.CreateWnd;
begin
  inherited;
  if(Items<>nil)and(Items.count=0)then
       Items.AddObject(BldRootDirectory,NetCloseBMP); //no parent error in create
end;

procedure TINetDirBx.DblClick;
begin
  inherited DblClick;
  LaunchResetFTPDir;
end;


procedure TINetDirBx.DeleteDirectoryRecord(const ADirName: String);
Var
  NewAction:TFTPCompActionList;
begin
  If FDirFTPThread=nil then exit;
  NewAction:=TFTPCompActionList.Create;
  NewAction.Action:= taRmDir;
  NewAction.CommandAction:= ADirName;
  NewAction.IterateDepth:=DeleteIterateDepth;
  FDirFTPThread.PushList(NewAction);
end;

Procedure TINetDirBx.DeleteFile(const AFileName: String);
Var
  NewAction:TFTPCompActionList;
begin
  If FDirFTPThread=nil then exit;
  NewAction:=TFTPCompActionList.Create;
  NewAction.Action:= taDeleteF;
  NewAction.CommandAction:= AFileName;
  FDirFTPThread.PushList(NewAction);
end;



Procedure TINetDirBx.DeleteListOfFiles(AList: TStringList;
  Continue: Boolean);
Var
  NewAction:TFTPCompActionList;
  Newlist:TStringList;
begin
  If FDirFTPThread=nil then exit;
  NewList:=TStringList.Create;
  NewList.AddStrings(AList);
  NewAction:=TFTPCompActionList.Create;
  NewAction.Action:= taDeleteFileList;
  NewAction.ListParameter:=Newlist;
  FDirFTPThread.PushList(NewAction);
end;

destructor TINetDirBx.Destroy;
begin
  FDirFTPThread.Free;
  ExeBMP.Free;
  UnknownBMP.Free;
  ClosedBMP.Free;
  OpenedBMP.Free;
  CurrentBMP.Free;
  TxtBMP.Free;
  PicBMP.Free;
  inherited;
end;

function TINetDirBx.DirectorySeparator: Char;
begin
  If FDirFTPThread<>nil
    then Result:=FDirFTPThread.FDirSep
   else Result:='\';          //Designing
end;

procedure TINetDirBx.DragOver(Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
Var
  CurrentItem:Integer;
begin
  inherited;
  if not accept then exit;
  CurrentItem:=ItemAtPos(Point(X,Y),True);
  If X>(ClientRect.Left*2+ClientRect.Right)div 3 then
        CurrentItem:=-1;
  //MultiSelect is false
  //If(ItemIndex>-1)And(ItemIndex<>CurrentItem)and MultiSelect then
  //           Selected[ItemIndex]:=false;
  ItemIndex:=CurrentItem;
end;

procedure TINetDirBx.DrawItem(Index: Integer; Rect: TRect;
  State: TOwnerDrawState);
Var
  lDirSep:Char;
     // put in object when bitmaps removed
     function DirLevel(const PathName: string): Integer;  { counts '\' in path }
        var
          P: PChar;
        begin
          Result := 0;
          If PathName='' then exit;
          P := AnsiStrScan(PChar(PathName), LDirSep);
          while P <> nil do
          begin
            Inc(Result);
            Inc(P);
            P := AnsiStrScan(P, LDirSep);
          end;
        end;


var
  Bitmap: TBitmap;
  bmpWidth: Integer;
  dirOffset: Integer;
begin
  with Canvas do
  begin
    If Index>(Items.Count-1) then
                                Exit;
    LDirSep:=DirectorySeparator;
    FillRect(Rect);
    bmpWidth  := 16;
    dirOffset := Index * 4 + 2;    {add 2 for spacing}
    Bitmap := TBitmap(Items.Objects[Index]);
    If(Bitmap<>nil)and(TObject(Bitmap)is TDirRecObj)then
          BitMap:=TDirRecObj(Items.Objects[Index]).DirBitMap;
    if Bitmap <> nil then
    begin
      if Bitmap = ClosedBMP then
        dirOffset := (DirLevel ({FNet}FDirectory) + 2) * 4 + 2;
      bmpWidth := Bitmap.Width;
      BrushCopy(Bounds(Rect.Left + dirOffset,
               (Rect.Top + Rect.Bottom - Bitmap.Height) div 2,
               Bitmap.Width, Bitmap.Height),
               Bitmap, Bounds(0, 0, Bitmap.Width, Bitmap.Height),
               Bitmap.Canvas.Pixels[0, Bitmap.Height - 1]);
    end;
    TextOut(Rect.Left + bmpWidth + dirOffset + 4, Rect.Top,Items[Index])
  end;
end;



function TINetDirBx.ExtendedFileList: TStringList;
begin
 if FDirFTPThread=nil then result:=nil
   else Result:=FDirFTPThread.FExtendedFileDescription;
end;


function TINetDirBx.FileExists(AFileName: string): TYesNoDontKnow;
Var
  NewAction:TFTPCompActionList;
  TryCount:Integer;
begin
  Result:=ynDontKnow;
  If FDirFTPThread=nil then exit;
  If FFileExistBusy then Exit;
 Try
      FFileExistBusy:=true;
      NewAction:=TFTPCompActionList.Create;
      NewAction.Action:= taExistF;
      NewAction.CommandAction:= AFileName;
      NewAction.ReturnProc:= FileExistsReturn;
      FFileExistingCompleted:=false;
      FFileExisting:=AFileName;
      FDirFTPThread.PushList(NewAction);
      TryCount:=0;
      While Not FFileExistingCompleted do
        Begin
          Sleep(500);
          Application.ProcessMessages;
          TryCount:=TryCount+1;
          If TryCount>20 then exit;//only wait 10 Seconds
        end;
      If FFileExisting='' then  result:=ynNo
        else If FFileExisting=AFileName then result:=ynYes;
  Finally
    FFileExistBusy:=False;
  end;
end;

procedure TINetDirBx.FileExistsReturn(ReturnList: TStringList); //Synchronized
begin
  If ReturnList=nil then FFileExisting:=''
   else
    Case ReturnList.Count of
       {1:if pos(ReturnList[0],FFileExisting)=0 then
              FFileExisting:=ReturnValueNullResult;}
       2:if pos(ReturnList[0],FFileExisting)<>0 then // this is the right file
           Begin
             if ReturnList[1]=ReturnValueNullResult then
                   FFileExisting:='';
           end
          else  FFileExisting:=ReturnValueNullResult
       else //Case
         FFileExisting:=ReturnValueNullResult;
      end;//case
    FFileExistingCompleted:=true;
end;

function TINetDirBx.FullDirectoryName: String;
begin
  If FCurrentDirectory<>nil then
     Begin
       Result:=FCurrentDirectory.FThisDirFullName;
       If Result[Length(Result)]<>FCurrentDirectory.FDirSep then
         Result:=Result+FCurrentDirectory.FDirSep;
     End
   else Result:='@';
end;

function TINetDirBx.GetDirectory: string;
Var
  BaseDir: TDirRecObj;
begin
  Result:=FCurrentServer.BaseDirFileName;
  If FDirFTPThread=nil then exit;
  BaseDir:=FDirFTPThread.FBaseDir;
  If(FCurrentDirectory=nil)then
        SetDirectory('');
  If(FCurrentDirectory<>nil)then
    Begin     {basedir/}
        If(BaseDir<>nil)and
          (pos(BaseDir.FThisDirFullName,FCurrentDirectory.FThisDirFullName)=1)then
              Result:=Copy(FCurrentDirectory.FThisDirFullName,
                          Length(BaseDir.FThisDirFullName)+1,
                          Length(FCurrentDirectory.FThisDirFullName))
          else     {/home/}
           Result:=FCurrentDirectory.FThisDirFullName;
    end
   else
     Result:=FCurrentServer.BaseDirFileName;
  FDirectory:=result;
end;

function TINetDirBx.GetDragObject: TDragObject;
Var
 Obj:TNetFileDrag;
begin
  Result:=nil;
  If FCurrentDirectory=nil then exit;
  Obj:=TNetFileDrag.Create;
  If Obj<>nil then
      Obj.FNetDir:=FCurrentDirectory;//Means Drag a Directory
  Result:=Pointer(Obj);
end;

function TINetDirBx.GetHost: String;
begin
  Result:=FCurrentServer.HostName;
end;

function TINetDirBx.GetPassword: String;
begin
  Result:=FCurrentServer.Password;
end;


function TINetDirBx.GetUser: String;
begin
  Result:=FCurrentServer.Username;
end;

procedure TINetDirBx.KeyPress(var Key: Char);
begin
  inherited KeyPress(Key);
  if (Word(Key) = VK_RETURN) then
    LaunchResetFTPDir;
end;

procedure TINetDirBx.LaunchBuildList;
Var
  NewAction:TFTPCompActionList;
begin
  If FDirFTPThread=nil then exit;
  NewAction:=TFTPCompActionList.Create;
  NewAction.Action:= taBuildList;
  FDirFTPThread.PushList(NewAction);
end;

procedure TINetDirBx.LaunchChangeServer(NewServer: TFTPServerRecord);
Var
  NewAction:TFTPCompActionList;
begin
  FCurrentServer.HostName:= '';
  NewServer.BaseDirFileName:='';
  If FDirFTPThread=nil then exit;
  FDirFTPThread.FDirectoryObject:=Self;
  FDirFTPThread.FCurrentThreadServer:=NewServer;
  FCurrentServer:=NewServer;
  Items.Clear;
  If FFileList<>nil then
         FFileList.Items.Clear;
 { With NewServer do
    If(HostName=DefHost)and(UserName=DefUser)and(Password=DefPass)
      and(FDirFTPThread.Host=DefHost)then exit;}
  If NewServer.HostName<>'' then
   begin
      FCurrentDirectory:=nil;
      NewAction:=TFTPCompActionList.Create;
      NewAction.Action:=taChangeServer ;
      FDirFTPThread.PushList(NewAction);
   end;
end;

procedure TINetDirBx.LaunchRename(ACurrentFileName, ANewFileName: String);
Var
  NewAction:TFTPCompActionList;
begin
  If FDirFTPThread=nil then exit;
  NewAction:=TFTPCompActionList.Create;
  NewAction.Action:= taRename;
  NewAction.CommandAction:= ACurrentFileName+FileNameSeparater+ANewFileName;
  FDirFTPThread.PushList(NewAction);
end;

procedure TINetDirBx.LaunchResetFTPDir;
Var
  NewAction:TFTPCompActionList;
begin
  If FDirFTPThread=nil then exit;
  NewAction:=TFTPCompActionList.Create;
  NewAction.Action:= taResetDir;
  FDirFTPThread.PushList(NewAction);
end;

procedure TINetDirBx.LaunchSetMakeDirectory(DirName: String;
  MakeIfNeeded: Boolean);
Var
  NewAction:TFTPCompActionList;
begin
  If FDirFTPThread=nil then Begin Items.clear; exit; end;;
  If(FDirFTPThread.FBaseDir=nil)then
           Items.clear;//items can contain dir references
  NewAction:=TFTPCompActionList.Create;
  NewAction.Action:= taSetDir;
  NewAction.CommandAction:=DirName;
  NewAction.IterateDepth:=99;// down to 99 levels
  If MakeIfNeeded then
            NewAction.Action:= taCreateDir;
  FDirFTPThread.PushList(NewAction);
end;

function TINetDirBx.ListOfCurrentFilesInDir: TStringlist;
begin
 if FDirFTPThread=nil then result:=nil
   else Result:=FDirFTPThread.FListOfCurrentFilesInDir;
end;

procedure TINetDirBx.ModifyServerDetails(Const AHostName, AUser,
  APassword: String);
begin
  If AHostName<>'' then
      FCurrentServer.HostName:=AHostName;
  If AUser<>'' then
      FCurrentServer.Username:=AUser;
  If APassword<>'' then
      FCurrentServer.Password:=APassword;
end;

procedure TINetDirBx.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) then
  begin
    if (AComponent = FFileList) then FFileList := nil
    else if (AComponent = FDirLabel) then FDirLabel := nil;
  end;
end;


Function TINetDirBx.ReadAllFilesInNetDirectory(FullDirPath,AMask: string;
  AFileList: TStrings; LayersOfSubDir, MaxFileCount: Integer):TYesNoDontKnow;
Var
  NewAction:TFTPCompActionList;
  TryCount:Integer;
begin
  Result:=ynDontKnow;
  If FDirFTPThread=nil then exit;
  if FReadListBusy then Exit;
  FReadListBusy:=true;
 Try
      NewAction:=TFTPCompActionList.Create;
      NewAction.Action:= taIterateAllFiles;
      NewAction.CommandAction:= FullDirPath+FileNameSeparater+AMask;
      NewAction.ReturnProc:=ReadAllFilesInNetDirectoryReturn;
      NewAction.IterateDepth:=LayersOfSubDir;
      FFileReadListCompleted:=false;
      FFileReadlistReturnList:=AFileList;
      FDirFTPThread.PushList(NewAction);
      TryCount:=0;
     Try
      While Not FFileReadListCompleted do
        Begin
          Sleep(500);
          Application.ProcessMessages;
          TryCount:=TryCount+1;
          If TryCount>120 then exit;//only wait 60 Seconds
        end;
      Finally
       FFileReadlistReturnList:=nil;  //Result is returned in AFilelist via this pointer
       if FFileReadListCompleted then Result:=FDirFTPThread.FReadAllFilesReturn;
      end;
 Finally
   FReadListBusy:=False;
 end;
end;

procedure TINetDirBx.ReadAllFilesInNetDirectoryReturn(
  ReturnList: TStringList);
begin
 Try
  if ReturnList=nil then Exit;
  If FFileReadlistReturnList<>nil then
    FFileReadlistReturnList.AddStrings(ReturnList);
 Finally
  FFileReadlistReturnList:=nil;
  FFileReadListCompleted:=true;
 end;
end;

procedure TINetDirBx.ReadBitmaps;
begin
  If NetCloseBMP<>nil then Raise Exception.Create('Dual Open ReadbitMaps');
//  MakeFileLoad:=TDirectoryListBox.Create(nil);
//  MakeFileLoad.FileCompareText('jjjjj','lllll');
//  MakeFileLoad.Free;
  NetopenBMP := TBitmap.Create;
  NetopenBMP.LoadFromResourceName(HInstance, 'ISNETHOST');
  NetCloseBMP := TBitmap.Create;
  NetCloseBMP.LoadFromResourceName(HInstance, 'ISNETNOHOST');
  OpenedBMP := TBitmap.Create;
//  OpenedBMP.LoadFromResourceName(HInstance, 'OPENFOLDER');
  OpenedBMP.Handle := LoadBitmap(HInstance, 'NETOPENFLD');

  ClosedBMP := TBitmap.Create;
//  ClosedBMP.LoadFromResourceName(HInstance, 'CLOSEDFOLDER');
  ClosedBMP.Handle := LoadBitmap(HInstance, 'NETCLSDFLD');

  CurrentBMP := TBitmap.Create;
//  CurrentBMP.LoadFromResourceName(HInstance, 'CURRENTFOLDER');
  CurrentBMP.Handle := LoadBitmap(HInstance, 'NETCURTFLD');

  ExeBMP := TBitmap.Create;
  ExeBMP.Handle := LoadBitmap(HInstance, 'NETEXEFL');
  UnknownBMP := TBitmap.Create;
  UnknownBMP.Handle := LoadBitmap(HInstance, 'NETUNKNFL');
  TxtBMP := TBitmap.Create;
  TxtBMP.Handle := LoadBitmap(HInstance, 'NETTXTFL');
  PicBMP := TBitmap.Create;
  PicBMP.Handle := LoadBitmap(HInstance, 'NETPICFL');
end;


function TINetDirBx.ReconstructFileDetails(const Filename,
  Details: String): String;

var
  i,UnixSize,UnixDate:integer;
  Filenam:String;
begin
  UnixDate:=UnixNameStart-UnixDateSize;
  UnixSize:=UnixDate-UnixSizeSize;
  Filenam:=FileName;
  Result:='';
  If FileNam[1]='.'Then Exit;
  If Details='' then Exit;
  i:=pos(Filename,Details);
  If UnixDirStructure then
    begin
      If Details[1]='d'then Filenam:=DirectorySeparator+FileName;
    end
   else
    If(Pos('<',Details)>9)then Filenam:=DirectorySeparator+FileName;
  if i<1 then Result:=Details
    else
     If UnixDirStructure then
      Result:=FileNam+chrTab+Copy(Details,UnixSize,UnixDate-UnixSize)+chrTab+
           Copy(Details,UnixDate,UnixNameStart-UnixDate)+chrTab+Copy(Details,1,UnixAccess-4)+chrTab+
           Copy(Details,UnixAccess,UnixSize-UnixAccess)
     else
      Result:=FileNam+chrTab+Copy(Details,NtSize,NtNameStart-NtSize)+chrTab+
           Copy(Details,1,NtSize);
end;

procedure TINetDirBx.RefreshIfFileInDirectory(FName: String);
Begin
  If FCurrentDirectory.FileMatchesDirectory(FName)then
         Update;
end;


procedure TINetDirBx.ResetItemHeight;
var
  nuHeight: Integer;
begin
  nuHeight := GetFontHeight(Font)+1;
  if nuHeight < (OpenedBMP.Height + 1) then nuHeight := OpenedBmp.Height + 1;
  ItemHeight := nuHeight;
end;


procedure TINetDirBx.SetDirectory(DirectoryName: string);
begin
  LaunchSetMakeDirectory(DirectoryName,False);
end;

procedure TINetDirBx.SetDirLabelCaption;
var
  DirWidth: Integer;
begin
  if(FDirLabel <> nil) then
   If FCurrentDirectory=nil then
     FDirLabel.Caption:='No Connection'
    else
      begin
        DirWidth := Width;
        if not FDirLabel.AutoSize then DirWidth := FDirLabel.Width;
        FDirLabel.Caption := FCurrentDirectory.MinimiseName(DirWidth, FDirLabel.Canvas);
      end;
end;

procedure TINetDirBx.SetHost(s: string);
begin
  ModifyServerDetails(s,'','');
end;


procedure TINetDirBx.SetNetFileList(Value: TINetFileBx);
begin
  If FFileList<>nil then FFileList.FDirList:=nil;
  If Value is TINetFileBx then
        FFileList:= Value;
  if FFileList <> nil then
   if FFileList.FDirList<>Self  then
      begin
        FFileList.NetDirectoryList:=Self;
        FFileList.FreeNotification(Self);
      end;
end;




procedure TINetDirBx.SetPassword(s: String);
begin
  ModifyServerDetails('','',s);
end;

procedure TINetDirBx.SetUser(s: String);
begin
  ModifyServerDetails('',s,'');
end;

function TINetDirBx.ShouldShow(ErrorS: String): boolean;
Var
   ErrorCode:Integer;
Const
   Offset=12;//Socket Error
begin
   Result:=False;
   ErrorCode:=StrToIntDef(Copy(ErrorS,Offset,8),0);
   Case ErrorCode of
    {Id_WSAEINTR: Result           := RSStackEINTR;
    Id_WSAEBADF: Result           := RSStackEBADF;}
    Id_WSAEACCES: Result:=True;// RSStackEACCES;
    {Id_WSAEFAULT: Result          := RSStackEFAULT;
    Id_WSAEINVAL: Result          := RSStackEINVAL;
    Id_WSAEMFILE: Result          := RSStackEMFILE;
    Id_WSAEWOULDBLOCK: Result     := RSStackEWOULDBLOCK;
    Id_WSAEINPROGRESS: Result     := RSStackEINPROGRESS;
    Id_WSAEALREADY: Result        := RSStackEALREADY;
    Id_WSAENOTSOCK: Result        := RSStackENOTSOCK;}
    Id_WSAEDESTADDRREQ: Result    := True;//RSStackEDESTADDRREQ;
    {Id_WSAEMSGSIZE: Result        := RSStackEMSGSIZE;
    Id_WSAEPROTOTYPE: Result      := RSStackEPROTOTYPE;
    Id_WSAENOPROTOOPT: Result     := RSStackENOPROTOOPT;
    Id_WSAEPROTONOSUPPORT: Result := RSStackEPROTONOSUPPORT;
    Id_WSAESOCKTNOSUPPORT: Result := RSStackESOCKTNOSUPPORT;
    Id_WSAEOPNOTSUPP: Result      := RSStackEOPNOTSUPP;
    Id_WSAEPFNOSUPPORT: Result    := RSStackEPFNOSUPPORT;
    Id_WSAEAFNOSUPPORT: Result    := RSStackEAFNOSUPPORT;
    Id_WSAEADDRINUSE: Result      := RSStackEADDRINUSE;}
    Id_WSAEADDRNOTAVAIL: Result:=True;//RSStackEADDRNOTAVAIL;
    Id_WSAENETDOWN: Result:=True;//RSStackENETDOWN;
    Id_WSAENETUNREACH: Result:=True;//RSStackENETUNREACH;
    Id_WSAENETRESET: Result:=True;//RSStackENETRESET;
    Id_WSAECONNABORTED: Result:=True;//RSStackECONNABORTED;
    {Id_WSAECONNRESET: Result      := RSStackECONNRESET;
    Id_WSAENOBUFS: Result         := RSStackENOBUFS;
    Id_WSAEISCONN: Result         := RSStackEISCONN;
    Id_WSAENOTCONN: Result        := RSStackENOTCONN;
    Id_WSAESHUTDOWN: Result       := RSStackESHUTDOWN;
    Id_WSAETOOMANYREFS: Result    := RSStackETOOMANYREFS;
    Id_WSAETIMEDOUT: Result       := RSStackETIMEDOUT;}
    Id_WSAECONNREFUSED: Result :=True;//RSStackECONNREFUSED;
    {Id_WSAELOOP: Result           := RSStackELOOP;
    Id_WSAENAMETOOLONG: Result    := RSStackENAMETOOLONG;}
    Id_WSAEHOSTDOWN: Result:=True;//RSStackEHOSTDOWN;
    Id_WSAEHOSTUNREACH: Result:=True;//RSStackEHOSTUNREACH;
    {Id_WSAENOTEMPTY: Result       := RSStackENOTEMPTY;
    Id_WSAEPROCLIM: Result        := RSStackEPROCLIM;
    Id_WSAEUSERS: Result          := RSStackEUSERS;
    Id_WSAEDQUOT: Result          := RSStackEDQUOT;
    Id_WSAESTALE: Result          := RSStackESTALE;
    Id_WSAEREMOTE: Result         := RSStackEREMOTE;

    Id_WSASYSNOTREADY: Result     := RSStackSYSNOTREADY;   }

    {Id_WSAVERNOTSUPPORTED: Result:=True;//RSStackVERNOTSUPPORTED;
    Id_WSANOTINITIALISED: Result:=True;//RSStackNOTINITIALISED;

    Id_WSAHOST_NOT_FOUND: Result:=True;//RSStackHOST_NOT_FOUND;
    Id_WSATRY_AGAIN: Result :=True;//RSStackTRY_AGAIN;
    {Id_WSANO_RECOVERY: Result     := RSStackNO_RECOVERY;
    Id_WSANO_DATA: Result         := RSStackNO_DATA;}
    End;//case

end;

Function TINetDirBx.TryUpdate(DoNow:Boolean):Boolean;
Var
  TimeSince:TDateTime;
begin
  TimeSince:=now-FTryUpdateTimer;
  if(TimeSince > 5/24/60)Or DoNow then //every five minutes
   Begin
    Update;
    FTryUpdateTimer:=Now;
    Result:=True;
   end
   Else Result:=False;
end;


function TINetDirBx.UnixDirStructure: Boolean;
begin
  Result:=FDirFTPThread.FUnixDirStructure;
end;

procedure TINetDirBx.Update;
begin
 If FDirFTPThread<>nil then
   If(FDirFTPThread.Host<>FCurrentServer.HostName)or
         (FDirFTPThread.User<>FCurrentServer.Username)or
         (FDirFTPThread.Password<>FCurrentServer.Password)or
          not FDirFTPThread.Connected then
           Begin
            LaunchChangeServer(FCurrentServer);
            Exit; //ChangeServer calls update
           end
         else  LaunchBuildList;
  //Change;
end;

{ TDirRecObj }


Function  TDirRecObj.AddObjToList(NewObj: TDirRecObj):TDirRecObj;
Var
 Mess:String;

begin
  Result:=NewObj;
  If newobj.FullFileName=FThisDirFullName then
    Begin
     Mess:= 'Adding existing New Dir Obbject::'+newobj.FullFileName+'>>'+FThisDirFullName;
     Raise Exception.Create(mess);
    end;
{       begin //no can do - called from create
         newobj.Free;
         Result:=self;
         exit;
       end;}
  if NewObj.FUpper=self then
    Begin
       if FChild=nil then FChild:=NewObj
     else
        Result:=FChild.AddObjToList(NewObj);
    end
   Else
    If NewObj.FUpper<>FUpper then
         Raise Exception.Create('Adding non compatible New Dir Obbject')
     else
      If FNext=nil then FNext:=NewObj
       else
        Result:=FNext.AddObjToList(NewObj);
end;


function TDirRecObj.BuildRelativeLocalPathName(const NetFileName,
  LocalBaseDirectory: String): String;
  // Build Local based Name from this "Drop" Directory
Var
  NewName:String;
  i:integer;
begin
  Result:='';
  If FThisDirFullName<>'' then
    If Pos(FThisDirFullName,NetFileName)=1 then
       NewName:=Copy(NetFileName,Length(FThisDirFullName)+1,Length(NetFileName))
     else exit
   else NewName:=NetFileName;
  While NewName[1]=FDirSep do
    NewName:=Copy(NewName,2,Length(NewName));
  If FDirSep<>'\' then
    Begin
     i:=pos(FDirSep,NewName);
     While i>0 do
       Begin
         NewName[i]:='\';
         i:=pos(FDirSep,NewName);
       end;
    end;
  Result:=ConcatToFullFileName(LocalBaseDirectory,NewName);
end;

function TDirRecObj.BuildRelativeNetPathName(Const LocalFileName,
  LocalBaseDirectory: String): String;
  // Build Server based Name from this "Drop" Directory
Var
  NewName:String;
  i:integer;
begin
  Result:='';
  If LocalBaseDirectory<>'' then
    If Pos(LocalBaseDirectory,LocalFileName)=1 then
       NewName:=Copy(LocalFileName,Length(LocalBaseDirectory)+1,Length(LocalFileName))
     else exit
   else NewName:=LocalFileName;
  i:=Pos(':',NewName);
  If i>0 then NewName:=copy(newName,i+1,Length(NewName));
  While NewName[1]='\'do
    NewName:=Copy(NewName,2,Length(NewName));
  If FDirSep<>'\' then
    Begin
     i:=pos('\',NewName);
     While i>0 do
       Begin
         NewName[i]:=FDirSep;
         i:=pos('\',NewName);
       end;
    end;
  If FThisDirFullName='' then Result:= FDirSep+NewName
   Else
    if FThisDirFullName[Length(FThisDirFullName)]=FdirSep Then
       Result:=FThisDirFullName+NewName
      else Result:=FThisDirFullName+FDirSep+NewName;
end;

constructor TDirRecObj.Create(const AFullDirName: String;
                              Var CreateDir: TDirRecObj);
Var
  DirUpName:String;
  NewUpperDir:TDirRecObj;

begin
  FThisDirFullName:=AFullDirName;
  If CreateDir=nil then
    Begin    ///this is the base directory
       NewUpperDir:=self;
       If pos('/',FThisDirFullName)>0 then
           FDirSep:='/'
         else
          If pos('\',FThisDirFullName)>0 then
              FDirSep:='\'
            else FDirSep:='/';
       DirUpName:=GetPathName(FThisDirFullName);
       FFileName:=Copy(FThisDirFullName,Length(DirUpName)+2,Length(FThisDirFullName));
       While DirUpName<>'' do
         Begin
           NewUpperDir:=TDirRecObj.Create(DirUpName,NewUpperDir);
           DirUpName:=GetPathName(DirUpName);
         end;
       CreateDir:=NewUpperDir;  //return Top Directory
       exit;
    end
   else
    FDirSep:=CreateDir.FDirSep;
  DirUpName:=GetPathName(FThisDirFullName);
  FFileName:=Copy(FThisDirFullName,Length(DirUpName)+2,Length(FThisDirFullName));
  If DirUpName=FDirSep then
    FThisDirFullName:=Copy(FThisDirFullName,2,Length(FThisDirFullName));
  If PosNoCase(FThisDirFullName,CreateDir.FullFileName)=1 then
    Begin //this is a higher directory
      If CreateDir.FUpper<>nil then
          Raise Exception.Create('Creating upper dir which exists');
                    //Exception Disposes
      CreateDir.FUpper:=Self;
      FChild:=CreateDir;
    end
   Else
    Begin
      If PosNoCase(CreateDir.FullFileName,FThisDirFullName)<>1 then
          Raise Exception.Create('Creating non matching Directory');
                    //Exception Disposes
      FUpper:=CreateDir;
      CreateDir.AddObjToList(Self);
                    //Exception Dispose if exists
    end;
end;




destructor TDirRecObj.Destroy;
begin
  FNext.Free;
  FChild.Free;
  inherited;
end;

function TDirRecObj.FileMatchesDirectory(const AFullFileName:string): Boolean;
//Checks to see if file path Matches the directory
Var
  Filedir:String;
begin
 Result:=false;
 If AFullFileName='' then Exit;
 if AnsiLastChar(AFullFileName)^ = FDirSep then  // This is a directory
         Filedir:=Copy(AFullFileName,1,Length(AFullFileName)-1)
        else
         Filedir:=GetPathName(AFullFileName);
  Result:=StrEquNoCase(Filedir,FThisDirFullName);
end;

function TDirRecObj.FindExistingBestMatch(
  const FullDirName: String): TDirRecObj;
Var
  LenNew,LenThis:Integer;
begin
  Result:=Self;
  If FullDirName=''then exit;
  If(PosNoCase(FullDirName,FThisDirFullName)=1)then
   Begin
     LenThis:=Length(FThisDirFullName);
     LenNew:=Length(FullDirName);
     if LenNew=LenThis then
                Result:=Self
     Else                  //             /sm/testExisting /sm/te
                           //             /sm/te/ExistingisLower /sm/te
                           //             /sm/tem/ExistingisLower /sm/te
      If  StrScan(@FThisDirFullName[LenNew],FDirSep)=nil Then
         Begin
          If FNext<>nil then
               Result:=FNext.FindExistingBestMatch(FullDirName);
         end
        Else
          If FUpper<>nil then
               Result:=FUpper.FindExistingBestMatch(FullDirName);
           // Else Result:=nil;
       Exit;
    end;
  If(Pos(FThisDirFullName,FullDirName)=1)
       And((FullDirName[Length(FThisDirFullName)+1]=FDirSep)or
           (FThisDirFullName=FDirSep))then
      Begin //Try Lower
        If FChild<>Nil then
               Result:=FChild.FindExistingBestMatch(FullDirName);
        If Result=nil then
                    Result:=Self;
      end
     else
      If FNext<>nil then
         Result:=FNext.FindExistingBestMatch(FullDirName);
      //else result:=nil
end;

function TDirRecObj.FindFullNameDownLevel(
  const FullDirName: String): TDirRecObj;

begin
  Result:=nil;
  If FullDirName=FThisDirFullName then
       Begin
        result:=self;
        Exit;
       end;
  if FChild=nil then exit;
  If(PosNoCase(FThisDirFullName,FullDirName)=1)and
     (Length(FThisDirFullName)<Length(FullDirName))then
            Result:=FChild.FindFullThisLevel(FullDirName);
end;

function TDirRecObj.FindFullThisLevel(
  const FullDirName: String): TDirRecObj;
begin
  Result:=nil;
  If(PosNoCase(FThisDirFullName,FullDirName)=1)then
     If (FThisDirFullName=FullDirName) then
         Result:=self
       else  Result:=FindFullNameDownLevel(FullDirName);
  If(Result=nil)and(FNext<>nil)then
        Result:=FNext.FindFullThisLevel(FullDirName);
end;

function TDirRecObj.GetPathName(const AFullFileName: String): String;
Var
  BackSlashPos:integer;
  PStart,PBack:PChar;
begin
  if (Length(AFullFileName) = 0) then
    Result:=''
   else
    begin
     if AnsiLastChar(AFullFileName)^ = FDirSep then
         Result:=GetPathName(Copy(AFullFileName,1,Length(AFullFileName)-1))
      Else
       begin
         PStart:=@AFullFileName[1];
         if (Pstart<>nil) then
            PBack:=AnsiStrRScan(PStart,FDirSep)
           else PBack:=nil;
         If(PBack<>nil) then BackSlashPos:=PBack-PStart
           else  BackSlashPos :=0;
         AnsiPos(FDirSep, AFullFileName);
         Result := Copy(AFullFileName, 1, BackSlashPos);
       end;
    end;
end;

function TDirRecObj.MakeFullNetFileName(
  const LocalFileName: String): String;
begin
  Result:=FThisDirFullName;
  If Result=FDirSep then Result:=Result+ExtractFileName(LocalFileName)
    Else Result:=Result+FDirSep+ExtractFileName(LocalFileName);
end;

function TDirRecObj.MinimiseName(MaxLen: Integer; Canvas:TCanvas):String;
Var
  Dir:String;
  ll,i:integer;
Begin
  Result := FullFileName;
  ll:=Length(FThisDirFullName);
  Dir:=Copy(FThisDirFullName,1,ll{-1}-Length(FFileName));
  while (Dir <> '') and (Canvas.TextWidth(Result) > MaxLen) do
   Begin
     i:=Pos(FDirSep,Dir);
     if i>0 then
        Dir:='...'+Copy(Dir,i+1,ll)
      Else Dir:='';
     Result:=dir+FFileName;
   end;
end;

function TDirRecObj.OneDirStepRef(const AFullDirName: String): String;
Var
  PSep,PStart:PChar;
  i:integer;

begin
  Result:='';
  i:=Pos(FThisDirFullName,AFullDirName);
  if i<>1 then exit;
  i:=Length(FThisDirFullName);
  If i>=Length(AFullDirName) then exit;
  If(i=1)and(FThisDirFullName='/') then i:=2 
   else i:=i+2;
  PStart:=@AFullDirName[i];
  Psep:=StrScan(PStart,FDirSep);
  If Psep=nil then
     Result:=PStart
   Else
     Result:=copy(AFullDirName,i,Psep-PStart);  // ..\dirLevelBase\newdir\LowerDir>> newdir
end;

{ TINetFileBx }
const
  DefaultMask = '*.*';


procedure TINetFileBx.BumpTabs(FName: String);
        Function TabString(Var NextChar:Pchar):String;
          Var
            NextTab:Pchar;
          Begin
            NextTab:=StrScan(NextChar,chr(9));
            If NextTab=nil then Result:=NextChar
              Else
                Begin
                  Result:=Copy(NextChar,1,NextTab-NextChar);
                  NextTab:=NextTab+1;
                end;
            NextChar:=NextTab;
          end;

Var
  i,TabI:integer;
  LnChar:PChar;
begin
  LnChar:=@FName[1];
  TabI:=2;
  While(LnChar<>nil)and(TabI<MaxTabs)do
     Begin
       i:=Canvas.TextWidth(TabString(LnChar))+10;
       if i>FTabWidth[TabI] then FTabWidth[TabI]:=i;
       TabI:=TabI+1;
     end;
end;

procedure TINetFileBx.Change;
begin
  FLastSel := ItemIndex;
  if FFileEdit <> nil then
  begin
    if Length(GetFileName) = 0 then
      FileEdit.Text := Mask
    else
      FileEdit.Text := GetFileName;
    FileEdit.SelectAll;
  end;
  if Assigned(FOnChange) then FOnChange(Self);
end;

procedure TINetFileBx.Click;
begin
  inherited Click;
  if FLastSel <> ItemIndex then
     Change;
   // Else             Stuffs up dblclick
     // RenameEdit;
end;

procedure TINetFileBx.CMFontChanged(var Message: TMessage);
begin
  inherited;
  ResetItemHeight;
end;

constructor TINetFileBx.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Width := 145;
  FMask := DefaultMask;  { default file mask is all }
  MultiSelect := False;    { default is not multi-select }
  FLastSel := -1;
  Sorted := True;
  Style := lbOwnerDrawFixed;
  ResetItemHeight;
end;


procedure TINetFileBx.CreateWnd;
begin
  inherited CreateWnd;
  ReadFileNames;
end;

procedure TINetFileBx.DblClick;
begin
  If(FDirList<>nil)and(Filename<>'')and
           (Filename[1]=FDirSep)then
       Begin
         FDirList.Directory:=FullFileName;
       end
   Else
    inherited DblClick;
end;

destructor TINetFileBx.Destroy;
begin
  FRenameEdit.Free;
  inherited;
end;

procedure TINetFileBx.DragOver(Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
Var
  CurrentItem,i:Integer;
begin
  inherited;
  if not accept then exit;
  If X>(ClientRect.Left+FTabWidth[1])then
           CurrentItem:=-1
      else   CurrentItem:=ItemAtPos(Point(X,Y),True);
  If MultiSelect then
       Begin
        If ItemIndex<>CurrentItem then
          If SelCount>0 then
            For i:=0 to Items.count-1 do
                Selected[i]:=False;
        If CurrentItem>-1 then
             Selected[CurrentItem]:=True;
       end
    else
        ItemIndex:=CurrentItem;
end;

procedure TINetFileBx.DrawItem(Index: Integer; Rect: TRect;
  State: TOwnerDrawState);
var
  Bitmap: TBitmap;
  offset,i,j: Integer;
  SLeft,SOut:String;
begin
  If Index>(Items.Count-1) then
           Exit;
  with Canvas do
  begin
    FillRect(Rect);
    if ShowGlyphs then
    begin
      Bitmap := TBitmap(Items.Objects[Index]);
      if Assigned(Bitmap) then
      begin
        BrushCopy(Bounds(Rect.Left + 2,
                  (Rect.Top + Rect.Bottom - Bitmap.Height) div 2,
                  Bitmap.Width, Bitmap.Height),
                  Bitmap, Bounds(0, 0, Bitmap.Width, Bitmap.Height),
                  Bitmap.Canvas.Pixels[0, Bitmap.Height - 1]);
      end;
    end;
    SLeft:=Items[Index];
    j:=1;
    offset := 0;
    While SLeft<>'' do
     Begin
        offset:=Offset+FtabWidth[j];
        i:=Pos(chrTab,SLeft);
        if i>1 then
          Begin
            SOut:=Copy(SLeft,1,i-1);
            SLeft:=Copy(SLeft,i+1,255);
          end
         Else
          Begin
            SOut:=SLeft;
            SLeft:='';
          end;
        TextOut(Rect.Left + offset, Rect.Top,SOut);
        j:=j+1;
        if j>MaxTabs then
                   j:=MaxTabs;
     end;
  end;
end;

function TINetFileBx.ExtractShortFileName(Const FileName: String): String;
begin
  If FLongFormFiles then
    Result:=Copy(FileName,1,Pos(chrTab,FileName)-1)
   else
    Result:=FileName;
end;

function TINetFileBx.GetDragObject: TDragObject;
Var
 Obj:TNetFileDrag;
 i:Integer;

begin
  Result:=nil;
  If FDirList=nil then exit;
  Obj:=TNetFileDrag.Create;
  if Obj=nil then exit;
  If MultiSelect and (SelCount>1) then
   For i:=0 to Items.Count-1 do
     Begin
      If Selected[i] then
       If(Items[i]<>'')and(Items[i][1]=fDirSep)then
          Selected[i]:=false
        Else
          Begin
           If Obj.FNetFileList=nil then
                   Obj.FNetFileList:=TStringList.Create;
           Obj.FNetFileList.Add(FDirectory+FDirSep+ExtractShortFileName(Items[i]))//extended format
          end;
     end;
  if(Obj.FNetFileList<>nil)and(Obj.FNetFileList.Count=1)then
    Begin
     Obj.FNetFileList.Free;
     Obj.FNetFileList:=nil;
    end;
  If Obj.FNetFileList=nil then  // only single selection
    Begin
       If SelectedIsDir then
          Begin
            Obj.FNetFileName:='';
            Obj.FNetDir:=FDirList.FCurrentDirectory.FindExistingBestMatch(FullFileName);//Means Drag a Directory
          end
        else
          Obj.FNetFileName:=FullFileName;
      end;
  Result:=Pointer(Obj);
end;

function TINetFileBx.GetFileName: string;
var
  idx: Integer;
begin
      { if multi-select is turned on, then using ItemIndex
        returns a bogus value if nothing is selected   }
  idx  := ItemIndex;
  if (idx < 0)  or  (Items.Count = 0)  or  (Selected[idx] = FALSE)  then
    Result  := ''
  else
    Result  := ExtractShortFileName(Items[idx]);
end;

function TINetFileBx.GetFullFileName: string;
Var
  s:String;
begin
  s:=FileName;
  if s='' then Result:=''
   Else
    If(s[1]=FDirSep)then
     Result:=FDirectory+s
    else
     Result:=FDirectory+FDirSep+s;
  if(Length(Result)>1)and(Result[1]=Result[2])then
    Result:=Copy(Result,2,Length(Result));
end;

procedure TINetFileBx.InPlaceEditOnExit(Sender: TObject);
begin
  If Sender<>FRenameEdit then exit;
  FReNameEdit.Visible:=False;
  If FCurrentFileName<>FRenameEdit.Text then
        RenameFile(FCurrentFileName,FRenameEdit.Text);
end;

procedure TINetFileBx.InPlaceEditOnKeyPress(Sender: TObject;
  var Key: Char);
begin
 if Key = #13 then
  begin
      Key := #0;
      FReNameEdit.Visible:=False;
 end;
end;

function TINetFileBx.MatchMask(Const FileNam: String): Boolean;
Var
 MaskPtr,ptr:PChar;
 Thismask,ext,fbit:String;
 LocalResult:Boolean;
begin
 Result:=true;
 if(Fmask='') then exit;
 MaskPtr:=@FMask[1];
 Result:=False;
 While(Not Result)and(MaskPtr<>nil)do
   Begin
     ThisMask:=FieldSep(MaskPtr,';');
     If ThisMask='*.*' then Result:=True
      else
         If ThisMask<>'' then
           Begin
             LocalResult:=True;
             Ptr:=@Thismask[1];
             fbit:=FieldSep(Ptr,'.');
             if Ptr=nil then
                 Ext:=''
               else
                 ext:=Pchar(ptr+1);
             if(fbit<>'*')and(Fbit<>FileNam)then
              Begin
                If pos('*',Fbit)>1 then
                   Begin
                    Fbit:=Copy(Fbit,1,pos('*',Fbit));
                    LocalResult:=Pos(Fbit,Filenam)=1;
                   end
                  Else LocalResult:=false;
              end;
             if LocalResult and(ext<>'')and(ext<>'*')then
              Begin
                If pos('*',ext)>1 then
                   Begin
                    ext:=Copy(ext,1,pos('*',Fbit));
                    LocalResult:=PosNoCase('.'+ext,Filenam)>1;
                   end
                  Else LocalResult:=PosNoCase('.'+ext,Filenam)>1;
              end;
            Result:=LocalResult;
           end;
   end;
end;

procedure TINetFileBx.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) then
  begin
    if (AComponent = FFileEdit) then FFileEdit := nil
    else if (AComponent = FDirList) then FDirList := nil
    else if (AComponent = FFilterCombo) then FFilterCombo := nil;
  end;
end;

procedure TINetFileBx.ReadFileNames;
Var
  i:Integer;
  LocalList:TStringList;
begin
  Items.Clear;
  For i:=1 to MaxTabs do FtabWidth[i]:=0;
  If FDirList=nil Then
    Begin
      Items.Add('No FTP Directory List Connection');
      Exit;
    end;
  FDirSep:=FDirList.DirectorySeparator;
  if FDirList.FCurrentDirectory<>nil then
        FDirectory:=FDirList.FCurrentDirectory.FThisDirFullName
      Else FDirectory:='';
  FDefaultBitMap:=FDirList.ClosedBMP;
  FtabWidth[1]:=FDefaultBitMap.Width+5;
  ResetItemHeight;
  if FLongFormFiles then
     LocalList:=FDirList.ExtendedFileList
   else
     LocalList:=FDirList.ListOfCurrentFilesInDir;
  if LocalList<>nil then
   For i:=0 to LocalList.count-1 do
     Begin
      if FLongFormFiles then
        BumpTabs(LocalList[i]);
      if(FMask='')or(pos('*.*',FMask)=1)or(pos(';*.*',FMask)>0)then
         Items.Addobject(LocalList[i],LocalList.objects[i])
        Else
          If MatchMask(ExtractShortFileName(LocalList[i]))then
         Items.Addobject(LocalList[i],LocalList.objects[i]);
     end;
  If Items.Count=0 then
    Items.Add('- No Files -');
end;

procedure TINetFileBx.RenameEdit;
var
  idx: Integer;
begin
 If FRenameEdit=nil then
    Begin
     FRenameEdit:=TEdit.Create(self);
     //FRenameEdit.ParentWindow:=handle;
     FRenameEdit.Parent:=Self;
     //or     FRenameEdit.parent := TWinControl(Self);
     FRenameEdit.OnKeyPress :=InPlaceEditOnKeyPress;
     FRenameEdit.OnExit:=InPlaceEditOnExit;
     FRenameEdit.Left := FDefaultBitMap.Width;
     FRenameEdit.BorderStyle := bsnone;
   end;
      { if multi-select is turned on, then using ItemIndex
        returns a bogus value if nothing is selected   }
  idx  := ItemIndex;
  if (idx < 0)  or  (Items.Count = 0)  or  (Selected[idx] = FALSE)
     Then Exit;
  FRenameEdit.Top :=ItemHeight*(Idx-TopIndex);
  FRenameEdit.width := width-FRenameEdit.Left;
  FRenameEdit.Height := ItemHeight;
  FRenameEdit.Visible := true;
  FCurrentFileName := ExtractShortFileName(Items[Idx]);
  FRenameEdit.text := FCurrentFileName;
  FRenameEdit.SetFocus;
  FRenameEdit.SelectAll;
end;

procedure TINetFileBx.RenameFile(const ACurrentFileName,ANewFileName: String);
begin
 If NetDirectoryList=nil then Exit;
 NetDirectoryList.LaunchRename(ACurrentFileName,ANewFileName);
 //NetDirectoryList.Update;
end;

procedure TINetFileBx.ResetItemHeight;
var
  nuHeight: Integer;
begin
  nuHeight := GetFontHeight(Font)+1;
  If FShowGlyphs and(FDefaultBitMap<>nil)then
     if nuHeight < (FDefaultBitMap.Height + 1) then nuHeight := FDefaultBitMap.Height + 1;
  ItemHeight := nuHeight;
end;

function TINetFileBx.SelectedIsDir: Boolean;
Var
 s:string;
begin
  Result:=False;
  S:=Filename;
  if(s<>'')and(s[1]=FDirSep)then
   Result:=True;
end;

procedure TINetFileBx.SetFileEdit(Value: TEdit);
begin
  FFileEdit := Value;
  if FFileEdit <> nil then
  begin
    FFileEdit.FreeNotification(Self);
    if GetFileName <> '' then
      FFileEdit.Text := GetFileName
    else
      FFileEdit.Text := Mask;
  end;

end;

procedure TINetFileBx.SetLongFormFiles(Value: Boolean);
begin
  FLongFormFiles:=Value;
  ReadFileNames;
end;

procedure TINetFileBx.SetMask(const NewMask: string);
begin
  if FMask <> NewMask then
  begin
    FMask := NewMask;
    ReadFileNames;
  end;
end;

procedure TINetFileBx.SetNetDirList(Value: TINetDirBx);
begin
  If Value is TINetDirBx then
    FDirList:= Value;
  if FDirList <> nil then
   if FDirList.FFileList<>Self then
        begin
          FDirList.NetFileList:=Self;
          FDirList.FreeNotification(Self);
        end;
  ReadFileNames;
end;

procedure TINetFileBx.SetShowGlyphs(Value: Boolean);
begin
  if FShowGlyphs <> Value then
  begin
    FShowGlyphs := Value;
    if (FShowGlyphs = True)and(FDefaultBitMap<>nil)and
             (ItemHeight <(FDefaultBitMap.Height+1))then
      ResetItemHeight;
    Invalidate;
  end;
end;

procedure TINetFileBx.Update;
begin
  ReadFileNames;
end;

{ TNetFileDrag }


{ TNetFileDrag }

destructor TNetFileDrag.Destroy;
begin
  FNetFileList.Free;
  inherited;
end;

function TNetFileDrag.FileName: String;
Var
  Nam:PChar;
begin
  Result:='';
  If  FNetDir<>nil then
    Result:=FNetFileName
   Else
    Begin
      Nam:=@FNetFileName[1];
      Nam:=AnsiStrRScan(Nam,FNetFileName[1]);
      if Nam<>nil then
        Begin
          Nam:=Nam+1;
          Result:=Nam;
        end
    end;
end;

procedure TNetFileDrag.Finished(Target: TObject; X, Y: Integer;
  Accepted: Boolean);
begin
    Free;
end;

function TNetFileDrag.FullNetFileName: String;
begin
  If(FNetDir=nil)then
    Result:=FNetFileName
   Else
    If FNetFileName=''then
       Result:=FNetDir.FThisDirFullName
     else
      If(FNetDir.FThisDirFullName=FNetDir.FDirSep)and
       (FNetFileName[1]=FNetDir.FDirSep)Then
         Result:=FNetFileName
        else
         Result:=FNetDir.FThisDirFullName+FNetFileName;
end;

function TNetFileDrag.IsDirectory: Boolean;
begin
   Result:=FNetDir<>nil;
end;

function TNetFileDrag.Multiple: Boolean;
begin
  Result:=IsDirectory;
  If(FNetFileList<>nil)and(FNetFileList.Count>0)then
       Result:=True;
end;

{ TFTPDirThread }

procedure TFTPDirThread.BusyCursorAndDisable;
Var
 LocalItemIndex:Integer;
begin
 Try
   FBusyCount:=FBusyCount+1;
   if FBusyCount>1 then exit;
   Assert(FDirectoryObject<>nil,'No Dir Object');
   FNetDirectory:='';
   //FSvEnable:=FDirectoryObject.Enabled;
   FSvCursor:=FDirectoryObject.Cursor;
   FDirectoryObject.Cursor:=crHourGlass;
   //FDirectoryObject.Enabled:=False;
   If FDirectoryObject.FFileList<>nil then
     Begin
      FDirectoryObject.FFileList.Cursor:=crHourGlass;
      //FDirectoryObject.FFileList.Enabled:=False;
     end;

   with FDirectoryObject do
    Begin
      LocalItemIndex:=ItemIndex;
      If LocalItemIndex>-1 then
         FSvCurIndexObj:=Pointer(Items.Objects[LocalItemIndex])
       else FSvCurIndexObj:=nil;
    end;
   If(FSvCurIndexObj<>nil)and not (FSvCurIndexObj is TDirRecObj)then
     FSvCurIndexObj:=nil;
 Except
  on e:exception do
   OutputDebugString(PChar(e.message));
 end;
end;

procedure TFTPDirThread.ChangeServer;
//Sets the server to the value in FCurrentThreadServer
//As this is set in other thread may leapfrog changes
var
  sMess:String;
begin
  sMess:='';
  If FFTPClient=nil then exit;
  If FDirectoryObject=nil then exit;
  Synchronize(BusyCursorAndDisable);
  FTopDir.Free;
  FTopDir:=nil;
  FBaseDir:=nil;
  FCurrentDirectory:=nil;
  if FListOfCurrentFilesInDir<>nil then
      FListOfCurrentFilesInDir.Clear;
  if FExtendedFileDescription<>nil then
      FExtendedFileDescription.Clear;
  if FListOfNetDir<>nil then
      FListOfNetDir.Clear;
 try
   Try
     If FFTPClient.Connected and
       Not((FFTPClient.User=FCurrentThreadServer.UserName)and
           (FFTPClient.Host=FCurrentThreadServer.HostName)and
           (FFTPClient.Password=FCurrentThreadServer.Password))
      then
        FFTPClient.Quit;
   Except
     //Can Expect Error
     //On E:Exception ReportFTPErrors(E.Message);
   end;
   If not FFTPClient.Connected then
     Begin
       FFTPClient.User:=FCurrentThreadServer.UserName;
       FFTPClient.Host:=FCurrentThreadServer.HostName;
       FFTPClient.Password:=FCurrentThreadServer.Password;
       FFTPClient.TransferType:=ftBinary;
       If (FCurrentThreadServer.HostName<>'') then
           If SimpleIPConnection(FCurrentThreadServer.HostName)then
                     FFTPClient.Connect(True)
            else
              if (UpperCase(FCurrentThreadServer.HostName)='LOCALHOST')or
                         (FCurrentThreadServer.HostName='127.1.1.1')
                              then  FFTPClient.Connect(True);
     end;
   If FFTPClient.Connected then
       Begin
         FCurrentThreadServer.BaseDirFileName:=FFTPClient.RetrieveCurrentDir;
         If FTopDir=nil then
           SetMakeDirectory(FCurrentThreadServer.BaseDirFileName,False,40);
         //ReadFtpDirectoryNames();
       end
     Else
          FCurrentThreadServer.BaseDirFileName:='No Connection';
 Except //Failed to Connect
  on E: Exception do
   Begin
       If FDirectoryObject.ShouldShow(E.message) then ReportFTPErrors(e.Message+' :: '+
                              FCurrentThreadServer.HostName);
        sMess:='Server Change Error::'+E.Message;
        OutputDebugString(@sMess[1]);
       // FCurrentServer.HostName:='';
   end;
 End;
 Synchronize(RecoverValues);
end;

function TFTPDirThread.CheckCurrentConnection: Boolean;
begin
 Result:=False;
   If FFTPClient=nil then Exit
 Else
   Result:=FFTPClient.Connected;
 If (Not Result)and(FFTPClient.Host<>'') then
   Begin
    Try
     If SimpleIPConnection(FFTPClient.Host)then
               FFTPClient.Connect(True);
    Except
    end;
     Result:= FFTPClient.Connected;
   end;
end;

function TFTPDirThread.Connected: Boolean;
begin
  If FFTPClient=nil then Result:=False
    else Result:=FFTPClient.Connected;
end;

constructor TFTPDirThread.Create;
begin
   Inherited Create(True);
   FObjLock:=TCriticalSection.Create;
   FDirSep:='/';
end;

procedure TFTPDirThread.DeleteDirectoryRecord(const ADirName: String);
  Var
    LocalList:TStringList;
    i,LenFileS:integer;
    FileS,NextDirPath,ThisDirPath:String;
    SaveCurrentFullDirName:String;
    SaveBaseDir,DirToDelete,NewCurrentDir:TDirRecObj;
begin
  ThisDirPath:=ADirName;
  SaveCurrentFullDirName:='';
  DirToDelete:=nil;
  If ThisDirPath[Length(ThisDirPath)]<>FDirSep then
     ThisDirPath:=ThisDirPath+FDirSep;
  SaveBaseDir:=FBaseDir;
  if SaveBaseDir<>nil then
    Begin
      DirToDelete:=SaveBaseDir.FindFullNameDownLevel(ADirName);
      SaveCurrentFullDirName:=FCurrentDirectory.FThisDirFullName
    end;
  If(FBaseDir<>nil)and(DirToDelete=nil)then Exit;
               // Something is wrong
  If(FBaseDir<>nil)and(FBaseDir=DirToDelete)then Exit;
               // Cannot delete base dir
  FBaseDir:=nil;
  Synchronize(BusyCursorAndDisable);
 Try
      LocalList:=TStringList.Create;
     Try
      FFTPClient.List(LocalList,'-p '+ADirName,False);
      i:=0;
      While i< LocalList.Count do
        Begin
         FileS:=LocalList[i];
         LenFileS:=Length(FileS);
         If FileS[LenFileS]='/' then
           Begin//is a Directory
            NextDirPath:=ADirName+FDirSep+Copy(FileS,1,LenFileS-1);
            DeleteDirectoryRecord(NextDirPath);
           end
          Else
            FFTPClient.Delete(ThisDirPath+FileS);
         i:=i+1;
        end;
      FFTPClient.RemoveDir(ADirName);
     Except
      on E:Exception do ReportFTPErrors(E.Message);
     End;
      LocalList.Free;
      If DirToDelete<>nil then
       Begin
        DirToDelete:=DirToDelete.FUpper.FindExistingBestMatch(
                          DirToDelete.GetPathName(DirToDelete.FThisDirFullName));
        DirToDelete.FChild.Free;
        DirToDelete.FChild:=nil;
        NewCurrentDir:=SaveBaseDir.FindExistingBestMatch(SaveCurrentFullDirName);
        If NewCurrentDir<>nil then
           Begin
            FBaseDir:=SaveBaseDir;
            SetDirectory(NewCurrentDir.FThisDirFullName);
           end;
       end;
     If FBusyCount<2 then
          ReadFtpDirectoryNames;
 Finally
  Synchronize(RecoverValues);
 end;
end;


Procedure TFTPDirThread.DeleteListOfFilesFile(AList: TStringList);
Var
 i:integer;
begin
 If Alist=nil then exit;
 Synchronize(BusyCursorAndDisable);
Try
 For i:=0 to Alist.count-1 do
     DeleteSingleFile(AList[i]);
 ReadFtpDirectoryNames;
Finally
 Synchronize(RecoverValues);
end;
end;

function TFTPDirThread.DeleteSingleFile(const AFileName: String): Boolean;
begin
  Synchronize(BusyCursorAndDisable);
  Result:=False;
 Try
  If Not CheckCurrentConnection then Exit;
  If Not FFTPClient.Connected then
      FFTPClient.Connect;
  FFTPClient.Delete(AFileName);
  Result:=True;
  If FBusyCount<2 then
      ReadFtpDirectoryNames;
 Except
      on E:Exception do ReportFTPErrors(E.Message);
 end;
 Synchronize(RecoverValues);
end;

destructor TFTPDirThread.Destroy; // Main Thread ????
begin
  If FObjLock<>nil then FObjLock.Acquire; //wait till complete
  If FDirectoryObject<>nil then
     FDirectoryObject.FCurrentDirectory:=nil;
  FListOfCurrentFilesInDir.Free;
  FExtendedFileDescription.Free;
  FListOfNetDir.Free;
  FCurAction.Free;
  FResultList.Free;
  FFTPClient.Abort;
  FFTPClient.Free;
  FFTPClient:=nil;
  FTopDir.Free;
  FTopDir:=nil;
  FCurrentDirectory:=nil;
  FBaseDir:=nil;
  FObjLock.Free;
  FCommandList.Free;
  Terminate;
  Resume;
  inherited;
end;

procedure TFTPDirThread.Execute;
    //inherited Execute; is abstract
begin
  FCurAction:=nil;
  If FFTPClient=nil then FFTPClient:=TIdFTP.Create(nil);
  While not Terminated do
    Begin
     If FFTPClient=nil then Terminate;
     If Terminated then Exit;
     FCurAction:=PopList;
     If Terminated then Exit;
     If FCurAction=nil then Suspend
      else
       Try
         Case FCurAction.Action of
          taList,taListDetails:Begin
                If FResultList=nil then FResultList:=TStringlist.Create;
                FResultList.Clear;
                 Try
                  FFTPClient.List(FResultList,FCurAction.CommandAction,FCurAction.Action=taListDetails);
                 Except
                      on E:Exception do ReportFTPErrors(E.Message);
                 end;
                Synchronize(ReturnProcedure);
              end;
           taChangeServer:ChangeServer;
           taResetDir:ResetCurrentFTPDir;
           taSetDir:SetMakeDirectory(FCurAction.CommandAction,False,FCurAction.IterateDepth);
           taCreateDir:SetMakeDirectory(FCurAction.CommandAction,True,FCurAction.IterateDepth);
           taRmDir:DeleteDirectoryRecord(FCurAction.CommandAction);
           taRename:RenameFile(FCurAction.CommandAction);
           taDeleteF:DeleteSingleFile(FCurAction.CommandAction);
           taExistF:Begin
                If FResultList=nil then FResultList:=TStringlist.Create;
                FResultList.Clear;
                FResultList.Add(FCurAction.CommandAction);
                if FileExists(FCurAction.CommandAction)then
                   FResultList.Add(ReturnValueValidResult)
                  else
                   FResultList.Add(ReturnValueNullResult);
                Synchronize(ReturnProcedure);
                end;
           taIterateAllFiles:Begin
                If FResultList=nil then FResultList:=TStringlist.Create;
                FResultList.Clear;
                with FCurAction do
                    FReadAllFilesReturn:=ReadAllFilesInNetDirectory(CommandAction,FResultList,IterateDepth,LimitSize);
                Synchronize(ReturnProcedure);
              end;
           taDeleteFileList:Begin
                 DeleteListOfFilesFile(FCurAction.ListParameter);
                 FCurAction.ListParameter.Free;
              end;
           taBuildList:ReadFtpDirectoryNames;
         end;  //Case;
         If Terminated then Exit;
         While  FBusyCount>0 do
             Synchronize(RecoverValues);
         Sleep(100);
       Except
        on e:exception do
         Begin
           If Terminated then Exit;
           ReportFTPErrors(e.Message);
           FreeAndNil(FCommandList);
           Sleep(1000); // Give it time to get over it
         end;
       end;
      FreeAndNil(FCurAction);
    end;
end;

function TFTPDirThread.ExtractShortNetFileName(
  const FileName: String): String;
var
  NextChar,RScanChar,LastSpaceChar:PChar;
begin
  NextChar:=@FileName[1];
  LastSpaceChar:=nil;
  RScanChar:=StrRScan(NextChar,' ');
  While RScanChar<>nil do
     Begin
      If LastSpaceChar<>nil then LastSpaceChar[0]:=' ';
      LastSpaceChar:=RScanChar;
      RscanChar:=RScanChar-1;
      If RscanChar[0]in['0'..'9']Then RscanChar:=nil
        Else
         If(RScanChar[0]=' ')and(Pos('<',FileName)>5)Then
           Begin
            If FUnixDirStructure then
              OutputDebugString('< found in Unix Structure');
            FUnixDirStructure:=False;
            If(Pos('<',FileName)<>NtDirStart)then
              OutputDebugString('< not atr Nt position');
            RScanChar:=nil;
           end
        Else
         Begin
          LastSpaceChar[0]:=chr(0);
          RScanChar:=StrRScan(NextChar,' ');
         end;
     end;
  If LastSpaceChar<>nil then
    Begin
      LastSpaceChar:=LastSpaceChar+1;
      Result:=LastSpaceChar;
      If FUnixDirStructure then
        Begin
          If(LastSpaceChar-NextChar)<>UnixNameStart then
            UnixNameStart:= (LastSpaceChar-NextChar)
             // OutputDebugString('Unix Name Start Error ')//+IntToStr(UnixNameStart));
          end
       else
        If(LastSpaceChar-NextChar+2)<>NtNameStart then
              OutputDebugString('NT Name Start Error ')//+IntToStr(NtNameStart));
    end;
end;

function TFTPDirThread.FileExists(AFileName: string): Boolean;
Var
  FSize:integer;
begin
  FSize:=0;
  Result:=FSize>0; //to set try vars without hints;
  If CheckCurrentConnection then
  Try
    FSize:=FFTPClient.Size(AFileName);
    if FSize>0 then Result:=True;
  except
      on E:Exception do ReportFTPErrors(E.Message);
  end;
end;

function TFTPDirThread.Host: String;
begin
  If FFTPClient<>nil then Result:=FFTPClient.Host
    else result:='';
end;

function TFTPDirThread.Password: String;
begin
  If FFTPClient<>nil then Result:=FFTPClient.Password
    else result:='';
end;

function TFTPDirThread.PopList: TFTPCompActionList;
begin
  Result:=nil;
  If FObjLock=nil then exit;
 Try
  FObjLock.Acquire;
  If FCommandList=nil then exit;
  Result:= FCommandList;
  FCommandList:=Result.Next;
  Result.Next:=nil;
 Finally
   FObjLock.Release;
 end;
end;

procedure TFTPDirThread.PushList(Item: TFTPCompActionList);
begin
  If FObjLock=nil then exit;
  If Item=nil then Exit;
 Try
  FObjLock.Acquire;
  If Item.Action = taChangeServer then
           FreeAndNil(FCommandList);
  If FCommandList=nil then
       FCommandList:=Item
     else
       FCommandList.AddToList(Item);
  If Suspended then Resume;
 Finally
   FObjLock.Release;
 end;
end;

Function TFTPDirThread.ReadAllFilesInNetDirectory(FullDirPathAndMask:string;
                               AFileList:TStrings;
                               LayersOfSubDir,MaxFileCount:Integer):TYesNoDontKnow;

Var
  NextDirPath,FileS,FullDirPath,AMask:String;
  LocalList:TStringList;
  i,LenFileS:Integer;
begin
  Result:=ynDontKnow;
  If FFTPClient=nil then Exit;
  i:=Pos(FileNameSeparater,FullDirPathAndMask);
  if i<1 then exit;
  FullDirPath:=copy(FullDirPathAndMask,1,i-1);
  i:=i+Length(FileNameSeparater);
  AMask:=copy(FullDirPathAndMask,i,Length(FullDirPathAndMask));
          { Cannot see Why?
          If FListOfCurrentFilesInDir<>nil then
                 FListOfCurrentFilesInDir.Clear;
          If FExtendedFileDescription<>nil then
                 FExtendedFileDescription.Clear;}
        //Synchronize(BusyCursorAndDisable);
 Try
      If AFileList=nil then Exit;
      If Not(AFileList is TStrings)then Exit;
      Result:=ynNo;
      If LayersOfSubDir<0 then Exit;
      If AFileList.Count>MaxFileCount then Exit;
      If FullDirPath[Length(FullDirPath)]<>FDirSep then
         FullDirPath:=FullDirPath+FDirSep;
      LocalList:=TStringList.Create;
     Try
        Try
          FFTPClient.List(LocalList,'-p '+FullDirPath,False);
          Result:=ynYes;
        Except
              on E:Exception do ReportFTPErrors(E.Message);
        end;
      i:=0;
      While i< LocalList.Count do
        Begin
         FileS:=LocalList[i];
         LenFileS:=Length(FileS);
         If FileS<>'' then
             If FileS[LenFileS]=FDirSep then
               Begin//is a Directory
                NextDirPath:=FullDirPath+Copy(FileS,1,LenFileS-1);
                Result:=ReadAllFilesInNetDirectory(NextDirPath+FileNameSeparater+AMask,
                                      AFileList,LayersOfSubDir-1, MaxFileCount);
               end
              Else
                AFileList.Add(FullDirPath+FileS);
         i:=i+1;
        end;
      Finally
        LocalList.Free;
      end;
 Finally
  //Synchronize(RecoverValues);
 end;
end;

procedure TFTPDirThread.ReadFtpDirectoryNames;
Var
 i:integer;
 s,FileName:string;
 LocalList:TStringList;
 gif:Pointer;
begin
 if FFTPClient=nil then exit;
 If FDirectoryObject=nil then exit;
 Synchronize(BusyCursorAndDisable);
Try
   if FListOfNetDir=nil then FListOfNetDir:=Tstringlist.Create;
   if FListOfCurrentFilesInDir=nil then
          FListOfCurrentFilesInDir:=TStringList.Create;
   if FExtendedFileDescription=nil then
          FExtendedFileDescription:=TStringList.Create;
   FListOfCurrentFilesInDir.Clear;
   FExtendedFileDescription.Clear;
   FListOfNetDir.Clear;
   LocalList:=TStringList.Create;
    Try
     FListOfNetDir.Sorted:=false;//just in case
     Try
        FFTPClient.List(LocalList,'',True);
     Except
       on e:exception do
         begin
           FListOfNetDir.Add('FTP Error:: '+e.Message);
           LocalList.Add('drw-rw-rw-   1 FTP FAIL FTP FAIL       0 May 27  1998 .');
         end;
     end;
     If(LocalList.Count<1)then Exit;
     If posnocase('total',Locallist[0])=1 then LocalList.Delete(0);//remove Red Hat
     If(LocalList.Count<1)then Exit;
     If(Locallist[0][1]='-')or(Locallist[0][1]='d') then //is Unix Format
          FUnixDirStructure:=True
          else FUnixDirStructure:=False;
     For i:=0 to Locallist.Count-1 do
       begin
        FileName:=ExtractShortNetFileName(LocalList[i]);
        S:=FDirectoryObject.ReconstructFileDetails(FileName,LocalList[i]);
        gif:=FDirectoryObject.ClosedBMP;
        If(S<>'')then
         If(S[1])=FDirSep then
              FListOfNetDir.Add(FileName)
         else
           Begin
            If(PosNoCase('.htm',Filename)>1)Or(PosNoCase('.txt',Filename)>1)then
              gif:=FDirectoryObject.TxtBMP
             else
              If(PosNoCase('.cgi',Filename)>1)Or(PosNoCase('.asp',Filename)>1)then
                gif:=FDirectoryObject.ExeBMP
               Else
              If(PosNoCase('.jpg',Filename)>1)Or(PosNoCase('.bmp',Filename)>1)then
                gif:=FDirectoryObject.PicBMP
               Else
                 gif:=FDirectoryObject.UnknownBMP;
                 //     ,PicBMP: TBitmap;
            FListOfCurrentFilesInDir.addobject(FileName,Gif);
           end;
        If S<>'' then FExtendedFileDescription.addobject(s,Gif);
       end;
     For i:=FListOfNetDir.Count-1 downto 0 do //PutDirectories in Front
            FListOfCurrentFilesInDir.InsertObject(0,FDirSep+FListOfNetDir[i],FDirectoryObject.ClosedBMP);
    Finally
      LocalList.Free;
    end;
 Finally
  Synchronize(RecoverValues);
 end;
end;

procedure TFTPDirThread.RecoverValues;//Synchronized
begin
    FBusyCount:=FBusyCount-1;
    if FBusyCount>0 then exit;
    Assert(FDirectoryObject<>nil,'No Dir Object');
    FDirectoryObject.FCurrentServer:=FCurrentThreadServer;
    FDirectoryObject.FCurrentDirectory:= FCurrentDirectory;
    if FBaseDir=nil then
       FDirectoryObject.Items.Clear;
    If FCurrentDirectory<>nil then
        begin
          FNetDirectory:=FCurrentDirectory.FThisDirFullName;
          FDirSep:=FCurrentDirectory.FDirSep;
        end
      Else
        Begin
          FNetDirectory:='';
          FDirSep:='/';
        end;
    FDirectoryObject.FDirectory:=FNetDirectory;
    FDirectoryObject.BuildList(FListOfNetDir);
    //FDirectoryObject.Enabled:=FSvEnable;
    FDirectoryObject.Cursor:=FSvCursor;
    If FDirectoryObject.FFileList<>nil then
     Begin
      FDirectoryObject.FFileList.Cursor:=FSvCursor;
      //FDirectoryObject.FFileList.Enabled:=FSvEnable;
     end;
    FDirectoryObject.Change;
end;


procedure TFTPDirThread.RenameFile(RenameCommand: String);
Var
 ACurrentFileName,ANewFileName:String;
 i:Integer;
begin
 If FFTPClient=nil then Exit;
 i:=Pos(FileNameSeparater,RenameCommand);
 if i<1 then exit;
 ACurrentFileName:=copy(RenameCommand,1,i);
 i:=i+Length(FileNameSeparater);
 ANewFileName:=copy(RenameCommand,i,Length(RenameCommand));
 If Length(ANewFileName)<1 then exit;
  Try
   If Not FFTPClient.Connected then
      FFTPClient.Connect;
   FFTPClient.Rename(ACurrentFileName,ANewFileName);
  Except
        on E:Exception do ReportFTPErrors(E.Message);
  end;
 FBaseDir:=nil;
 SetMakeDirectory('',False,40);
end;

procedure TFTPDirThread.ReportFTPErrors(AString: String);
begin
  If(FDirectoryObject=nil)then Exit;
  If Assigned(FDirectoryObject.FOnReportFTPErrors)then
    FDirectoryObject.FOnReportFTPErrors(AString)
   else
    ShowMessage('FTP Error: '+AString);
end;

procedure TFTPDirThread.ResetCurrentFTPDir;
var
  NewDir:TDirRecObj;
begin
 If FDirectoryObject=nil then exit;
 Synchronize(BusyCursorAndDisable);
 try
  NewDir:=FSvCurIndexObj;
  If(NewDir<>nil)and not(Tobject(NewDir)is TDirRecObj)then
       NewDir:=nil;
  If NewDir=nil then
    If FCurrentDirectory<>nil then
            NewDir:=FCurrentDirectory.FUpper
        Else NewDir:=nil;
  If Newdir<>nil then
    SetMakeDirectory(NewDir.FullFileName,False,40);
 Finally
 Synchronize(RecoverValues);
 end;
end;

procedure TFTPDirThread.ReturnProcedure;
//Use where Return needs to be syncronised
begin
   If Assigned(FCurAction.ReturnProc) then FCurAction.ReturnProc(FResultList);
end;

procedure TFTPDirThread.SetDirectory(const NewDirectory: string);
begin
  Synchronize(BusyCursorAndDisable);
  Try
    SetMakeDirectory(NewDirectory,False,40);
  Finally
    Synchronize(RecoverValues);
  end;
end;

function TFTPDirThread.SetMakeDirectory(AFullFileName:String;
               AMakeDirOnServer:Boolean; AMaxIterateDepth:Integer):Boolean;
//Set or make the directory
//AFilename Directory to find or make
//AMakeDirOnServer if true make a directory if not found
//AMaxIterateDepth go no deeper than this

    {sub}Function RecurseMakeDirectory(AFullFileName:String;
               AMakeDirOnServer:Boolean; AMaxIterateDepth:Integer):Boolean;
                  Var
                    FileDirectoryName:String;
                   // PSep,PStart:PChar;
                    NewDir:TDirRecObj;
                  begin
                    Synchronize(BusyCursorAndDisable);
                   Try
                    Result:=False;
                    Try
                      FDirRecursionCheck:=FDirRecursionCheck+1;
                      If FDirRecursionCheck>AMaxIterateDepth then Exit;
                      If Not FFTPClient.Connected then exit;
                     Try
                        UpdateCurrentNetDir;
                     Except
                        Exit;
                     end;
                     If FBaseDir=nil then
                        Begin
                          FTopDir.Free;
                          FTopDir:=nil;
                          FCurrentDirectory:=nil;
                          If FDirectoryObject<>nil then
                               FDirectoryObject.FCurrentDirectory:=nil;
                          FBaseDir:=TDirRecObj.Create(FNetDirectory,FTopDir);
                          If FBaseDir<>nil then  FDirsep:=FBaseDir.FDirSep;
                        end;
                      If FBaseDir=nil then Exit;
                      If FCurrentDirectory=nil then
                          FCurrentDirectory:=FBaseDir.FindExistingBestMatch(FNetDirectory);
                      If Not StrEquNoCase(FCurrentDirectory.FullFileName,FNetDirectory) then
                         FFTPClient.ChangeDir(FCurrentDirectory.FThisDirFullName);
                      If Not StrEquNoCase(FCurrentDirectory.FullFileName,FNetDirectory) then
                          Raise Exception.Create('Set Directory Out of Step');
                      Result:=True;
                      If AFullFileName <>''then
                      {Else Exit -- Just Set up File}
                        Begin
                          FileDirectoryName:=AFullFileName;  // ../dirLevelBase/newdir\
                          If FileDirectoryName<>FCurrentDirectory.FullFileName then
                          {Else Exit -- all done}
                           Begin
                            If (Pos(FCurrentDirectory.FullFileName,FileDirectoryName)=1) then
                               Begin//Go deeper
                                 Try
                                   FFTPClient.ChangeDir(FCurrentDirectory.OneDirStepRef(FileDirectoryName));
                                 Except
                                   on E:Exception do
                                   If AMakeDirOnServer then
                                     Begin
                                      Try
                                       FFTPClient.MakeDir(FCurrentDirectory.OneDirStepRef(FileDirectoryName))
                                      Except
                                        on EE:Exception do
                                          Raise Exception.Create('Make Directory Error::'+EE.Message);
                                      end;
                                     end
                                    Else
                                      Raise Exception.Create('Set Directory Error::'+E.Message);
                                 End;
                                 UpdateCurrentNetDir;
                                 NewDir:=FCurrentDirectory.FindFullNameDownLevel(FNetDirectory);
                                 If NewDir=nil then
                                    NewDir:=TDirRecObj.Create(FNetDirectory,FCurrentDirectory);
                                 If NewDir<>nil then FCurrentDirectory:=NewDir;
                                 if Not FCurrentDirectory.FileMatchesDirectory(AFullFileName)then
                                   Result:=RecurseMakeDirectory(AFullFileName,AMakeDirOnServer,AMaxIterateDepth);
                               end
                              else
                                Begin//go back
                                  FFTPClient.ChangeDirUp;
                                  UpdateCurrentNetDir;
                                  FCurrentDirectory:=FCurrentDirectory.FUpper;
                                  if(FCurrentDirectory=nil)or
                                     Not StrEquNoCase(FCurrentDirectory.FullFileName,FNetDirectory)then
                                      Raise Exception.Create('Set Directory Out of Step - Non Matching Change Up');
                                  If Not FCurrentDirectory.FileMatchesDirectory(AFullFileName)then
                                     Result:=RecurseMakeDirectory(AFullFileName,AMakeDirOnServer,AMaxIterateDepth);
                                end;
                           end;
                        end;
                      FDirRecursionCheck:=FDirRecursionCheck-1;
                      If FDirRecursionCheck<1 then
                            ReadFtpDirectoryNames;
                    Except
                      on E:Exception do
                       Begin
                       FTopDir.Free;
                       FTopDir:=nil;
                       //Items.Clear;
                       FBaseDir:=nil;
                       FCurrentDirectory:=nil;
                       FNetDirectory:='';
                       //Raise
                       end;
                    end;
                   Finally
                    Synchronize(RecoverValues);
                   end;
               end;
Begin
  FDirRecursionCheck:=0;
  Result:=RecurseMakeDirectory(AFullFileName,AMakeDirOnServer,AMaxIterateDepth);
  If Not Result then
      FFTPClient.Abort;
end;


procedure TFTPDirThread.UpdateCurrentNetDir;
Var
  i:integer;
begin
  FNetDirectory:=FFTPClient.RetrieveCurrentDir;
  i:=Length(FNetDirectory);
  if(i>1)and(FNetDirectory[i]=FDirSep)then
   FNetDirectory:=Copy(FNetDirectory,1,i-1);
end;


function TFTPDirThread.User: String;
begin
  If FFTPClient<>nil then Result:=FFTPClient.User
    else result:='';
end;

{ TFTPCompActionList }

procedure TFTPCompActionList.AddToList(NewOne: TFTPCompActionList);
begin
  if NewOne is TFTPCompActionList then
    If Next= nil then Next:=NewOne
      else Next.AddToList(NewOne);
end;

destructor TFTPCompActionList.Destroy;
begin
  Next.Free;
  inherited;
end;

{ TLclFileBx }

procedure TLclFileBx.DblClick;
Var
  TempFileName:String;
begin
  TempFileName:=FileName;
  If DirectoryExists(TempFileName)and(FDirList<>nil)then
       Begin
         FDirList.Directory:=TempFileName;
       end
   Else
     inherited;
end;

destructor TLclFileBx.Destroy;
begin
  TxtBMP.Free;
  PicBMP.Free;
  inherited;
end;

function TLclFileBx.GetFilePath: string;
Var
  TempName:String;
  idx: Integer;
begin
  Result := '';
      { if multi-select is turned on, then using ItemIndex
        returns a bogus value if nothing is selected   }
  idx  := ItemIndex;
  if (idx < 0)  or  (Items.Count = 0)  or  (Selected[idx] = FALSE)  then
    TempName  := ''
  else
    TempName:= Items[idx];
  If (TempName<>'')Then
   Begin
    If TempName[1]='\' then
     TempName:=Copy(TempName,2,Length(TempName));
    If AnsiLastChar(FDirectory)^ <> '\' then
       Result := FDirectory + '\' + TempName
      else
       Result := FDirectory + TempName;
   end;
end;

procedure TLclFileBx.ReadBitMaps;
begin
  inherited;
  TxtBMP := TBitmap.Create;
  TxtBMP.Handle := LoadBitmap(HInstance, 'NETTXTFL');
  PicBMP := TBitmap.Create;
  PicBMP.Handle := LoadBitmap(HInstance, 'NETPICFL');
end;

procedure TLclFileBx.ReadFileNames;
var
  I: Integer;
  FileExt: string;
  DirItems:TstringList;
  FileInfo: TSearchRec;
  SaveCursor: TCursor;
  Glyph: TBitmap;
const
  AttrWord: Word=DDL_DIRECTORY;
  MaskPtr:PChar='*.*';

begin
      { if no handle allocated yet, this call will force
        one to be allocated incorrectly (i.e. at the wrong time.
        In due time, one will be allocated appropriately.  }
    ChDir(FDirectory); { go to the directory we want }
    Clear; { clear the list }
    //I := 0;
    SaveCursor := Screen.Cursor;
    DirItems:=TStringlist.Create;
    try
      Screen.Cursor := crHourGlass;
      DirItems.Sorted:=True;
      if FindFirst(MaskPtr, AttrWord, FileInfo) = 0 then
        begin
          repeat
            if (FileInfo.Attr and faDirectory)<>0 then
              begin
                If(FileInfo.Name<>'.')and(FileInfo.Name<>'..')then
                Begin
                  I := DirItems.Add(Format('\%s',[FileInfo.Name]));
                  if ShowGlyphs then
                     DirItems.Objects[I] := DirBMP;
                end
              end
              else
              begin
                FileExt := AnsiLowerCase(ExtractFileExt(FileInfo.Name));
                Glyph := UnknownBMP;
                if (FileExt = '.exe') or (FileExt = '.com') or
                  (FileExt = '.bat') or (FileExt = '.pif') or
                  (FileExt = '.cgi') or (FileExt = '.asp') then
                  Glyph := ExeBMP;
                if (FileExt = '.txt') or  (FileExt = '.htm') or
                  (FileExt = '.doc') then
                  Glyph := TxtBMP;
                if (FileExt = '.gif') or  (FileExt = '.jpg') or
                  (FileExt = '.bmp') then
                  Glyph := PicBMP;
                {I := }Items.AddObject(FileInfo.Name, Glyph);
              end;
          until FindNext(FileInfo) <> 0;
          FindClose(FileInfo);
          If DirItems.Count>0 then
            For  I:=DirItems.Count-1 downTo 0 do
               Items.InsertObject(0,DirItems[i],DirItems.Objects[i]);
        end;
    finally
      Screen.Cursor := SaveCursor;
      DirItems.Free;
    end;
    Change;
end;

end.
