unit LibBits;
{Small Bits out of Innova Libraries to support IsInternetComponents Package
}

interface
Uses SysUtils,WinSock;
Function ConcatToFullFileName(const Path, FileNam: String): String;
Function PosNoCase(Substr: string; S: string): Integer;
Function FieldSep(Var ss:pchar; SepVal:Char):ShortString;
Function StrEquNoCase(Const s1,s2:String):Boolean;
Function SimpleIPConnection(const TestLocalAddress:String): Boolean;

implementation
Function StrEquNoCase(Const s1,s2:String):Boolean;
Begin
  Result:=Length(s1)=Length(s2);
  If Result Then Result:=PosNoCase(s1,s2)=1;
end;

Function CopyNullStrToPascal(InStr:PChar;Count:Integer):string;
Begin
 If Count<0 then count:=StrLen(InStr);
 SetLength(Result,count);
 If Count>0 then
    strLcopy(@Result[1],InStr,Count);
end;


Function FieldSep(Var ss:pchar; SepVal:Char):ShortString;
VAR
  CharPointer:PChar;
  j:integer;

Begin
 If ss<>nil then
  Begin
    If (SepVal<>Chr(0)) then While ss[0]=SepVal do ss:=ss+1;
    CharPointer:=StrScan(ss,SepVal);
    If CharPointer=nil then
       result:=StrPas(ss) {Last Field}
    Else
     Begin
       j:=CharPointer-ss;
       result:= CopyNullStrToPascal(ss,j);
     end;
    If Charpointer=nil then ss:=nil else ss:=CharPointer+1;
  end
   Else result:='';
 End;

Function ConcatToFullFileName(const Path, FileNam: String): String;
begin
  if AnsiLastChar(Path)^ <> '\' then
   If FileNam[1]='\' then
      Result := Path + FileNam
    else
      Result := Path + '\' + FileNam
  else
   If FileNam[1]='\' then
    Result := Path + FileNam
   else result:=Path+Copy(FileNam,1,99) ;
end;

Function PosNoCase(Substr: string; S: string): Integer;
 Begin
   if (Substr='')or(s='')then Begin Result:=-1; Exit; end;
   SetLength(SubStr,Length(SubStr)); //get unique copy;
   SetLength(s,Length(s));
   StrLower(@s[1]);
   StrLower(@SubStr[1]);
   Result:=Pos(SubStr,S);
 end;

Function GetThisHostName:String;
var
  WSAData: TWSAData;
begin  { no error checking...}
   WSAStartup(2, WSAData);
   SetLength(Result, 255);
   Gethostname(PChar(Result), 255);
   SetLength(Result, StrLen(PChar(Result)));
End;


Function GetThisHostIPAddress:String;
var
  HostEnt: PHostEnt;
begin
  HostEnt := gethostbyname(PChar(GetThisHostName));
  If HostEnt=nil then Result:=''
   Else
    with HostEnt^  do
     Result := Format('%d.%d.%d.%d',[Byte(h_addr^[0]),Byte(h_addr^[1]),
                                     Byte(h_addr^[2]),Byte(h_addr^[3])]);
end;

Function SimpleIPConnection(const TestLocalAddress:String): Boolean;
 Var
   IPAddress:String;
 begin
   IPAddress:=GetThisHostIPAddress;
   If IPAddress='127.1.1.1' Then IpAddress:='';
   If(IpAddress='')and(TestLocalAddress<>'')then
     Begin
      IpAddress:=UpperCase(Trim(TestLocalAddress));
      If(IpAddress<>'LOCALHOST')and(IpAddress<>'127.1.1.1') then IpAddress:='';
     end;
   Result:=IPAddress<>'';
 end;

end.
